//echo("DEBUGTEST:  Start of server.cs");



//Use gamemode.txt to set the round time limit, in seconds

//We need zones to work, so exec the custom Event_Zones server.cs that this gamemode uses
exec("./EventZonesServer.cs");


//important sounds
datablock AudioProfile(Sound_PizzaPickUp)
{	
   filename    = "./PickUp.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_PizzaPickUpFull)
{
   filename    = "./PickUpFull.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_PizzaDeliver)
{
   filename    = "./ArekanDeliver.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_SatisfiedCustomer1)
{
   filename    = "./FryExcited.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_Excellent)
{
   filename    = "./Excellent.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_Alright)
{
   filename    = "./Alright.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_BassKick)
{
   filename    = "./BassKick.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_bombActivate)
{
   filename    = "./bombActivate.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_PizzaExplode1)
{
   filename    = "./Explode1.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_PizzaExplode2)
{
   filename    = "./Explode2.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(Sound_PizzaExplode3)
{
   filename    = "./Explode3.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(boost3Sound)
{
  filename    = "./Boost3.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(timerBeep1)
{
  filename    = "./timerBeep1.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(timerBeep2)
{
  filename    = "./timerBeep2.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(bombTransfer)
{
  filename    = "./bombTransfer.wav";
   description = AudioDefault3d;
   preload = true;
};






//echo("DEBUGTEST:  Persistence stuff being defined");
//Load a default add-on that helps to save people's stats when they leave the server, and state the variables that should be saved (includes money, #deliveries, playtime, total wins, wins per mode, and name)
LoadRequiredAddOn("Script_Player_Persistence");
if(isFunction(RegisterPersistenceVar))
{
  RegisterPersistenceVar("storedMoney", false, "");			
  RegisterPersistenceVar("totalDelivs", false, "");
  RegisterPersistenceVar("totalPlaytime", false, "");
  RegisterPersistenceVar("totalWins", false, "");
  RegisterPersistenceVar("totalM1Wins", false, "");
  RegisterPersistenceVar("totalM2Wins", false, "");				//tag addgamemode
  RegisterPersistenceVar("totalM3Wins", false, "");
  RegisterPersistenceVar("name", false, "");
  RegisterPersistenceVar("vehicleChoice", false, "");
  RegisterPersistenceVar("hasVehicle1", false, "");
  RegisterPersistenceVar("hasVehicle2", false, "");
  RegisterPersistenceVar("hasVehicle3", false, "");
  RegisterPersistenceVar("hasVehicle4", false, "");
  RegisterPersistenceVar("hasVehicle5", false, "");
  RegisterPersistenceVar("hasVehicle6", false, "");
  RegisterPersistenceVar("hasVehicle7", false, "");
  RegisterPersistenceVar("hasVehicle8", false, "");
  RegisterPersistenceVar("hasReadHelp", false, "");
  RegisterPersistenceVar("highestWinstreak", false, "");
}



//VVVV |COMPASS| VVVV/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function rotateUnitVector2d(%vec, %theta) {
        %x = getWord(%vec,0);
        %y = getWord(%vec,1);
        %costheta = mCos(%theta);
        %sintheta = mSin(%theta);
        //echo(%x SPC %y SPC %costheta SPC %sintheta);
        %ret = (%costheta * %x - %sintheta * %y) SPC (%sintheta * %x + %costheta * %y);
}


function get2dVecDist(%a,%b) {
		//echo("DEBUGTEST:  function get2dVecDist");
        %a = getWords(%a,0,1);
        %b = getWords(%b,0,1);
        return VectorDist(%a, %b);
}




function getCompassThreshold(%x) {
		//echo("DEBUGTEST:  function getCompassThreshold");
        %p = 21;
        if(%x <= 30) {
                if(%x > 20) {
                        %asdf = 1 - ((%x - 20) / 10);
                        %p -= 18 * %asdf;
                }
                else {
                        %p = 3;
                }
        }
        return ((2 * mPow(%x, 1/%p)) / mPow(640, 1/%p)) - 1;
}

function compassPrint(%client,%target,%l,%r) {
	//echo("DEBUGTEST:  function compassPrint");
		if(isObject(%client.player))
			%player1 = %client.player;
        %player2 = %target;				//player2 is actually the dropoff location, so view it as the bot waiting for pizza
		if($DelivMode == 3 && %client == $bomberClient)
		{
			%player2 = $closeToBomber.player;
		}
        if(isObject(%client.player) || $DelivMode == 3) {
                if(isObject(%player2) || $DelivMode == 3) {
					if(($DelivMode == 3 && %client == $bomberClient && isObject(%client.player)) || ($DelivMode != 3 && isObject(%client.player)))
					{
						%pos1 = getWords(%player1.getPosition(),0,1);
						%pos2 = getWords(%player2.getPosition(),0,1);
						%diff = VectorSub(%pos2,%pos1);
						%dist = VectorLen(%diff);
						%diff = VectorNormalize(%diff);
					}
					
					if(isObject(%client.player) && isObject(%client.player.getControlObject()))			//If player is in vehicle, use the vehicle's direction instead of the player's head direction for the compass
					{
						%veh = %client.player.getControlObject();
						%eyevec = getWords(%veh.getForwardVector(),0,1);
					}
					else if(isObject(%player1))
					{
						%eyevec = getWords(%player1.getEyeVector(),0,1);
					}
					
					%eyevec = VectorNormalize(%eyevec);
					%startvec = rotateUnitVector2d(%eyevec,$pi/2);
					if($DelivMode == 1 || $DelivMode == 2)
					{
						if($DelivMode == 2)
							%deliveryWorth = mCeil(1.5*(0.1*(vectorDist(%client.deliverFromPos,%client.deliverTo.getposition()))));
						else if($DelivMode == 1)
							%deliveryWorth = mceil(0.1*(vectorDist(%client.deliverFromPos,%client.deliverTo.getposition())));
				
						%str = "<just:left>" @ %l @ "<br><font:Impact:24>\c3NEXT PAY  <color:32c132>$" @ %deliveryWorth @ "<just:right>" @ (%client.pizzaCount < 1 ? "<font:Impact:29><color:ff4c4c>OUT OF PIZZA " : %r) @ "<br><just:center><font:arial:53>";
					}
					
					if($DelivMode == 3)
					{
						if(isObject($bomberClient.player))
							%str = "<just:left>" @ %l @ "<br><font:Impact:24>\c3BOMB TIME  \c6" @ $bombTimer @ "<just:right><font:Impact:24>\c3BOMBER \c6" SPC $bomberClient.getPlayerName() @ " <br><just:center><font:arial:53>";
						else
							%str = "<just:left>" @ %l @ "<br><font:Impact:24>\c3BOMB TIME \c6 --<just:right><font:Impact:24>\c3SELECTING BOMBER \c6" @ $selectBomberTimer @ " <br><just:center><font:arial:53>";
					}

					if(($DelivMode == 3 && %client == $bomberClient && isObject(%client.player)) || ($DelivMode != 3 && isObject(%player1)))
					{
						//hacky workaround to torque assuming %i has some infinitesimal difference between it and $pi
						%count = 0;
						for(%i=0; %i - -$pi > -0.00001; %i-= $pi / 16) {
							%curvec = rotateUnitVector2d(%startvec,%i);
							%col = VectorDot(%curvec, %diff) > getCompassThreshold(%dist); //when close, want left part small. when far, want left part large
							%z1 = getWord(%player1.getPosition(), 2);
							%z2 = getWord(%player2.getPosition(), 2);
							%math = %z1 + 4;
							%math2 = %z1 - 4;

							%str = %str @ (%col ? "\c4" : "\c7") @ "_";
			
							%count++;
							if(%count > 10000) {
									talk("somethin fucked up with the compass");
									cancel($compassSchedule);
									break;
							}
						}
					}
			
					if(getSimTime() - $lastfire > 1000 && %client == findclientbyname("[]")) {
							$lastFire = getSimTime();
					}
                }
				
                %client.bottomPrint(%str,1,1);
        }
        //talk(%diff);
}

function compassLoop()
{
	//echo("DEBUGTEST:  Calling function compassLoop");
	cancel($compassSchedule);

    	
	for(%j = 1; %j <= 20; %j++)
	{
		$VehicleSpawnBricks[%j].isVehicleActive = 0;
	}

	
	//If vehicle spawns have been deleted (usually due to map change), reset appropriate client variables - these help to establish their vehicles upon spawning
	if(!isObject($VehicleSpawnBricks[1]))
	{
		for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
		{
			%cl = $DefaultMinigame.member[%i];
			%cl.hasVehicleSpawn = 0;
			%cl.alreadySpawned = "";
			%cl.hasStartedFirstTimerSchedule = 0;
		}
	}
	
	//Make sure $modename is set to the proper string		tag addgamemode
	if($DelivMode == 1 && ((strCmp($modeName,"ONE FOR ONE") == 1) || (strCmp($modeName,"ONE FOR ONE") == -1)))
	{
		$modeName = "ONE FOR ONE";
	}
	else if($DelivMode == 2 && ((strCmp($modeName,"ONE FOR ALL") == 1) || (strCmp($modeName,"ONE FOR ALL") == -1)))
	{
		$modeName = "ONE FOR ALL";
	}
	else if($DelivMode == 3 && ((strCmp($modeName,"EXPLOSIVE PIZZA") == 1) || (strCmp($modeName,"EXPLOSIVE PIZZA") == -1)))
	{
		$modeName = "EXPLOSIVE PIZZA";
	}	
	
	if($DelivMode != 3) //tag addgamemode - add any modes to if statement if delivery bots aren't needed
	{
		for(%j = 1; %j <= $PizzaDeliveryGamemodeNumLocations; %j++)			//Constantly check through every delivery location to spawn/despawn necessary bots
		{

			if($PizzaDeliveryGamemodeLocations[%j].isDeliveryActive == 0 && isObject($PizzaDeliveryGamemodeBots[%j].hbot))
			{
					$PizzaDeliveryGamemodeBots[%j].hBot.schedule(3000, "delete");
			}

			if($PizzaDeliveryGamemodeLocations[%j].isDeliveryActive == 1 && !isObject($PizzaDeliveryGamemodeBots[%j].hbot))
			{
				$PizzaDeliveryGamemodeBots[%j].spawnHoleBot();
				$PizzaDeliveryGamemodeBots[%j].hbot.setBotPowered(0);
			}
			
			if($PizzaDeliveryGamemodeLocations[%j].isDeliveryActive == 1)
			{
				//this is constantly setting bots to power off - could this cause lag? idk
				$PizzaDeliveryGamemodeBots[%j].hbot.setBotPowered(0);
			}
			
			$PizzaDeliveryGamemodeLocations[%j].isDeliveryActive = 0;
		}
	}

	
	if($DelivMode == 3)
	{
		//Method to transfer bomb from bomb carrier to any player that is close and not behind a brick
		if(isObject($bomberClient.player) && $bombActive == 1)
		{
			%bomberPosition=$bomberClient.player.getHackPosition();
			InitContainerRadiusSearch(%bomberPosition,4,$TypeMasks::PlayerObjectType);
			while(%targetObject=containerSearchNext())
			{
				if(%targetObject != $bomberClient.player && $bombActive == 1)			
				{
					%end = %targetObject.getHackPosition();
					%type = $TypeMasks::FxBrickObjectType; 	//bricks with raycasting on
					%raycast = containerRaycast(%bomberPosition,%end,%type);	//looks for objects of type FxBrickObject between bomber and %targetObject
					if(firstWord(%raycast) == 0 && $bombActive == 1)			//if true, there are no raycasting bricks between the 2 players
					{
						//At this point, we know the %targetObject (a player) is near the bomb-holder and not behind a brick
						
						//de-activate the bomb for 5 seconds to allow for the previous bomb holder to escape
						$bombActive = 0;
						
						//Award bomb-transferrer money for transferring bomb
						$bomberClient.score += 25;
						$bomberClient.storedMoney += 25;
						
						//Send message to everyone saying who the bomb transferred to
						messageAll( '', "<font:impact:21>\c6 The bomb was transferred from \c3" @ $bomberClient.getPlayerName() @ "\c6 to \c3" @ %targetObject.client.getPlayerName());
						
						//hand off pizza bomb animation
						$bomberClient.player.playthread(1,armreadyright);
						$bomberClient.player.mountImage(BombPizza2Image,1);
						$bomberClient.player.activateStuff();
						$bomberClient.player.schedule(250,unMountImage,1);
						$bomberClient.player.schedule(250,playthread,1,root);
						
						//set the new bomber
						$bomberClient = %targetObject.client;
						
						//play sound to everyone to show that the bomb has been transferred
						for(%j = 0; %j < $DefaultMinigame.numMembers; %j++)
						{
							%mgcl = $DefaultMinigame.member[%j];
							%mgcl.play2D(bombTransfer);
						}
						
						//SET TARGET FOR BOMBER (closest player to bomber)
						%numAlive = 0;
						for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
						{
							%client = $DefaultMinigame.member[%i];

							//Get distances of each player from the bomb carrier in an array
							if(isObject($bomberClient.player) && isObject(%client.player) && %client != $bomberClient)
							{
								%numAlive += 1;	
								%dist = mCeil(vectorDist($bomberClient.player.getHackPosition(),%client.player.getHackPosition()));
								%newTest = %dist;
								if(%numAlive == 1)
									%oldTest = %newTest;
								if(%newTest <= %oldTest)
								{
									%oldTest = %newTest;
									$closeHo3 = %client;
								}
							}
						}
						$closeToBomber = $closeHo3;
						
						schedule(4000,0,activateBomb,0);
					}
				}
			}
		}
		
	}
	
	%numAliveM3 = 0;	//will be used to count number of players alive for mode 3
    for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
    {
    	%cl = $DefaultMinigame.member[%i];
		
		
		
		if(%cl.toggleBoard == 1)
		{
			showScoreBoard(%cl);
		}
		
		
		//If in Mode 3
		if ($DelivMode == 3)
		{
			//Make sure pizzaCount is always 0 (this tells the compass not to show up)
			if(%cl.pizzacount != 0)
			{
				%cl.pizzacount = 0;
			}
	
			//Give $bomberClient the bombPizza and fuse emitter (if bombActive) and make sure no one else has it
			if(isObject($bomberClient.player) && isObject(%cl.player))
			{
				if(%cl == $bomberClient && isObject(%cl.player) && %cl.player.isImageMounted(BombPizzaImage) == 0)
				{
					$bomberClient.player.hideNode("pack");
					$bomberClient.player.mountImage(BombPizzaImage,2);				//add bomb pizza to carry on back
				}
				if(%cl == $bomberClient && $bombActive == 1 && isObject(%cl.player) && %cl.player.isImageMounted(BombPizza_Emitter_Image) == 0)
				{
					$bomberClient.player.mountImage(BombPizza_Emitter_Image,0);		//add bomb fuse emitter
				}
				if(%cl != $bomberClient && isObject(%cl.player) && %cl.player.isImageMounted(BombPizzaImage))
				{
					%cl.player.unmountimage(2);				//remove bomb pizza from back
				}
				if(%cl != $bomberClient && isObject(%cl.player) && %cl.player.isImageMounted(BombPizza_Emitter_Image))
				{
					%cl.player.unmountimage(0);			//remove bomb fuse emitter
				}
			}
			
			//Count number of players alive	- will do this in a different for loop later in the script
			if(isObject(%cl.player))
				%numAliveM3 += 1;
		}
		
		//lets the server know that the bot is being delivered to and should be spawned
		%cl.deliverTo.isDeliveryActive = 1;
		
		//lets the server know that the client's vehicle spawn is being used and should not be assigned to another person
		%cl.perVehicleSpawn.isVehicleActive = 1;
		
		//don't let scores go below zero (this was only a problem when ctrl+k caused a score penalty)
		if(%cl.score < 0)
		{
			%cl.score = 0;
		}

		//if playing mode 2 and someone doesn't have the mode 2 delivery location, fix that
		if($DelivMode == 2 && %cl.deliverTo != $Mode2Deliv)
		{
			%cl.deliverTo = $Mode2Deliv;
		}
		
		//show a 'win' message to whoever won
		if(($DelivMode == 1 && %cl.score >= 350 && %cl.alreadyWon == 0) || ($DelivMode == 2 && %cl.score >= 350 && %cl.alreadyWon == 0))		//WINPOINTS - edit other lines too if you want to change this - ctrl f "WINPOINTS"
		{
			%cl.winRace();
			%cl.deliverTo = "";
			%cl.alreadyWon = 1;
			$somebodyWonPizzaDelivRound = 1;
			//%client.bottomPrint("<just:center><font:impact:68>\c2YOU WIN!",10,1);
		}

		//Remove/add pizzabox on player's back if they are out/have pizza
		if(isObject(%cl.player))
		{
			if (%cl.pizzaCount == 0 && %cl.player.isImageMounted(PizzaSmall1Image))
				%cl.player.unmountimage(2);
			if (%cl.pizzaCount > 0 && !%cl.player.isImageMounted(PizzaSmall1Image))
			{
				%cl.player.hideNode("pack");
				%cl.player.mountimage(PizzaSmall1Image,2);
			}
		}
		
		//if(!isObject(%cl.player)) continue;

		//%health = mFloor( ( 100 - %cl.player.getDamageLevel() ) / 10 );
		//%bar = "<font:impact:36>" @ getBarStr( %health, 10 );
		
		//Bottomprint Text (Displays Per-round money, Next Pay, Compass, and Pizzacount of the client)
		//if(isObject(%cl.player) && isObject(%cl.perVehicleSpawn.vehicle))
		//{
			//<font:Impact:24>\c3
			%l = "<font:Impact:43><color:32c132>$" @ (!%cl.storedMoney ? "0" : %cl.storedMoney) @ " ";		//Faraday - %l was changed from displaying 'health & kills' to displaying 'score'
			//if the player has a full carrying capacity of pizza (depends on current vehicle), display "max" beside the pizzacount that shows on the player screen
			//%clientCurrentVehicle = %cl.perVehicleSpawn.vehicle.getdatablock();
			//if (%cl.pizzaCount == 3 && (%clientCurrentVehicle == $DeliveryVehicles[1] || %clientCurrentVehicle == $DeliveryVehicles[2] || %clientCurrentVehicle == $DeliveryVehicles[3]))	//tag addvehicle
			//{
			//	%r = "<font:Impact:24>\c3CARRYING \c6" SPC %cl.pizzaCount @ "<font:Impact:21> (MAX) ";
			//}
			//else if(%cl.pizzaCount == 4 && (%clientCurrentVehicle == $DeliveryVehicles[4] || %clientCurrentVehicle == $DeliveryVehicles[5] || %clientCurrentVehicle == $DeliveryVehicles[6]))
			//{
			//	%r = "<font:Impact:24>\c3CARRYING \c6" SPC %cl.pizzaCount @ "<font:Impact:21> (MAX) ";
			//}
			//else if(%cl.pizzaCount == 5 && (%clientCurrentVehicle == $DeliveryVehicles[7]))
			//{
			//	%r = "<font:Impact:24>\c3CARRYING \c6" SPC %cl.pizzaCount @ "<font:Impact:21> (MAX) ";
			//}
			//else
			//{
				%r = "<font:Impact:24>\c3CARRYING \c6" SPC %cl.pizzaCount @ " ";
			//}
			
			if(%cl.deliverTo $= "")
			{
				%target = "Searching. . .";
			}
			else
			{
				if(!isObject(%cl.deliverTo)) continue;
				if(%cl.pizzaCount >= 1)
				{
							%target = %cl.deliverTo;
				}
				//if player has no pizza left, make the compass direct them back to the pizza item location (at the pizza parlour)
				else
				{
					%target = $PizzaDeliveryGamemodePizzaLocation;
				}
			}

				
			compassPrint(%cl,%target,%l,%r);

		//}
		//else
		//{
		//	%cl.bottomPrint("", 0.5, 1);
		//}
    }
	
	
	if($DelivMode == 3)
	{		
		//Update number of survivors
		$M3numAlive = %numAliveM3;
	}
	
	//delete vehicle if no player is using it - players are assigned a vehicle spawnbrick upon spawning in the server for the first time 
	for(%j = 1; %j <= 20; %j++)
	{
		if($VehicleSpawnBricks[%j].isVehicleActive == 0 && isObject($VehicleSpawnBricks[%j].vehicle))
		{
			$VehicleSpawnBricks[%j].vehicle.delete();
		}
	}

	//only show compass while someone has not won the round
    if($somebodyWonPizzaDelivRound != 1)
    {
    	$compassSchedule = schedule(33,0,compassLoop);
    }
}

//function getBarStr( %bar, %total )
//{
//    %barColor = %bar > 6 ? "\c2" : ( %bar < 3 ? "\c0" : "\c3" );
//    %restColor = "\c7";
//    %str = %barColor;
//
//    for( %i = 0; %i < %total; %i++ )
//    {
//        if( %i == %bar )
//            %str = %str @ %restColor;
//
//        %str = %str @ "-";
//    }
//    return %str;
//}

//^^^^ |COMPASS| ^^^^/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function showScoreBoard(%client)
{
	//echo("DEBUGTEST: function showScoreBoard");
	%mg = $DefaultMiniGame;
	
	if($DelivMode == 1 || $DelivMode == 2)	
	{
		if(%mg.numMembers > 0)
		{
			%oldTest = 0;
			%newTest = 0;
			%mg = $DefaultMiniGame;
			for(%i = 0; %i < %mg.numMembers; %i++)
			{
				%member = %mg.member[%i];
				%newTest = %member.score;
				if(%i == 0)
					%oldTest = %newTest;
				if(%newTest >= %oldTest)
				{
					%oldTest = %newTest;
					%Client1st = %member;
				}
			}
		}
		if(%mg.numMembers > 1)
		{
			%oldTest = 0;
			%newTest = 0;
			for(%i = 0; %i < %mg.numMembers; %i++)
			{
				%member = %mg.member[%i];
				if(%member == %Client1st) continue;
				%newTest = %member.score;
				if(%i == 0 || (%i == 1 && %mg.member[0] == %Client1st))
					%oldTest = %newTest;
				if(%newTest >= %oldTest)
				{
					%oldTest = %newTest;
					%Client2nd = %member;
				}
			}
		}
		if(%mg.numMembers > 2)
		{
			%oldTest = 0;
			%newTest = 0;
			for(%i = 0; %i < %mg.numMembers; %i++)
			{
				%member = %mg.member[%i];
				if(%member == %Client1st || %member == %Client2nd) continue;
				%newTest = %member.score;
				if(%i == 0 || (%i == 1 && %mg.member[0] == %Client1st) || (%i == 1 && %mg.member[0] == %Client2nd) || (%i == 2 && %mg.member[0] == %Client1st && %mg.member[1] == %Client2nd) || (%i == 2 && %mg.member[1] == %Client1st && %mg.member[0] == %Client2nd))
					%oldTest = %newTest;
				if(%newTest >= %oldTest)
				{
					%oldTest = %newTest;
					%Client3rd = %member;
				}
			}
		}
		
		if($DefaultMiniGame.numMembers == 1)
			centerprint(%client,"<just:right><font:impact:22>\c3" @ getSubStr(%Client1st.getPlayerName(),0,15) @ "    \c6" @ %Client1st.score @ " ",1);
		else if(%mg.numMembers == 2)
		{
			%name1 = getSubStr(%Client1st.getPlayerName(),0,15);
			%name2 = getSubStr(%Client2nd.getPlayerName(),0,15);
			centerprint(%client,"<just:right><font:impact:22>\c3" @ %name1 @ "    \c6" @ %Client1st.score @ " \n\c3" @ %name2 @ "    \c6" @ %Client2nd.score @ " ",1);
		}
		else if(%mg.numMembers > 2)
		{
			%name1 = getSubStr(%Client1st.getPlayerName(),0,15);
			%name2 = getSubStr(%Client2nd.getPlayerName(),0,15);
			%name3 = getSubStr(%Client3rd.getPlayerName(),0,15);
			centerprint(%client,"<just:right><font:impact:22>\c3" @ %name1 @ "    \c6" @ %Client1st.score @ " \n\c3" @ %name2 @ "    \c6" @ %Client2nd.score @ " \n\c3" @ %name3 @ "    \c6" @ %Client3rd.score @ " ",1);
		}
	}
	
	if($DelivMode == 3)
	{
		%mg = $DefaultMiniGame;
		%surviveCount = 0;
		for(%i = 0; %i < %mg.numMembers; %i++)
		{
			%member = %mg.member[%i];
			if(isObject(%member.player))
				%surviveCount += 1;
		}
		centerprint(%client,"<just:right><font:impact:22>\c3 Survivors: \c6" @ %surviveCount @ " ",1);
	}
}

function serverCmdToggleBoard(%client)
{
	//echo("DEBUGTEST: function serverCmdToggleBoard");
	if(%client.toggleBoard == 0)
		%client.toggleBoard = 1;
	else
		%client.toggleBoard = 0;
}

function selectBomberCountDownLoop()
{
	//echo("DEBUGTEST:  called function selectBomberCountDownLoop");
	cancel($selectBomberSchedule);
	$selectBomberTimer--;
	if($selectBomberTimer != 0)
	{
		$selectBomberSchedule = schedule(1000,0,selectBomberCountDownLoop);
	}
}


function activateBomb (%selectNewBomber)	//yyy
{
	$bomberGoneDetect = 0;
	//echo("DEBUGTEST:  function activateBomb");
	//echo("Number of players alive: " @ $M3numAlive);
	if($M3numAlive > 1 && $DelivMode == 3 && $somebodyWonPizzaDelivRound == 0)	//tag m3win
	{						//tag m3win
		//echo("DEBUGTEST:  called function activateBomb");
		//this tells when the bomb can be transferred
		$bombActive = 1;
		
		//play sound to bomb holder to tell when the bomb has activated / can be transferred
		$bomberClient.play2d(Sound_bombActivate);
		
		//play alert sound to all players when someone gets bomb pizza - and count number of player still alive
		%numAlive = 0;
		for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
		{
			%cl = $DefaultMinigame.member[%i];
			if(isObject(%cl.player))
				%numAlive += 1;
		}
		
		//choose random person to become bomberClient at start of round and after ppl explode
		if(%selectNewBomber)
		{	
			if(%numAlive > 0)
			{
				while(%cancelWhile != 1)
				{
					%randNum = getRandom(0,$DefaultMinigame.numMembers - 1);
					if(isObject($DefaultMinigame.member[%randNum].player))
					{
						//start bomb timer counting down from 40
						$bombTimer = 41;
						bombTimerLoop();
						
						//Set new bomberClient
						$bomberClient = $DefaultMinigame.member[%randNum];
						messageAll( '', "<font:impact:21>\c6 A bomb was given to \c3" @ $bomberClient.getPlayerName());
						%cancelWhile = 1;
					}
				}
			}
		}
		
		//SET TARGET FOR BOMBER (closest player to bomber)
		%numAlive = 0;
		for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
		{
			%client = $DefaultMinigame.member[%i];

			//Get distances of each player from the bomb carrier in an array
			if(isObject($bomberClient.player) && isObject(%client.player) && %client != $bomberClient)
			{
				%numAlive += 1;	
				%dist = mCeil(vectorDist($bomberClient.player.getHackPosition(),%client.player.getHackPosition()));
				%newTest = %dist;
				if(%numAlive == 1)
					%oldTest = %newTest;
				if(%newTest <= %oldTest)
				{
					%oldTest = %newTest;
					$closeHo2 = %client;
				}
			}
		}
		$closeToBomber = $closeHo2;
		
	}	//tag m3win
}

function bombTimerLoop()	
{
	//echo("DEBUGTEST:  called function bombTimerLoop");
	cancel($bombTimerSchedule);
	
	if($somebodyWonPizzaDelivRound == 0) 
		$bombTimer--;
	
	//Play countdown beeps for last few seconds
	for(%q = 0; %q < $DefaultMinigame.numMembers; %q++)
	{
		%mgCl = $DefaultMinigame.member[%q];
		if($bombTimer == 10 || $bombTimer == 9 || $bombTimer == 8 || $bombTimer == 7 || $bombTimer == 6 || $bombTimer == 5)
			%mgCl.play2d(timerBeep1);
		if($bombTimer == 4 || $bombTimer == 3 || $bombTimer == 2 || $bombTimer == 1)
			%mgCl.play2d(timerBeep2);
	}
		
	
	
	if($bombTimer == 0 && $DelivMode == 3)
	{
		$bombTimer = "--";
		$bomberClient.player.spawnExplosion(tankShellProjectile,0.8);
		$bomberClient.player.kill();
		
		//play explosion sound to everyone except bomb holder
		%numberAlive = 0;
		for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
		{
			%cl = $DefaultMinigame.member[%i];
			if(isObject(%cl.player))
				%numberAlive += 1;

			%ranBoomSound = getRandom(1,3);
			if(%ranBoomSound == 1)
				%cl.play2d(Sound_PizzaExplode1);
			if(%ranBoomSound == 2)
				%cl.play2d(Sound_PizzaExplode2);
			if(%ranBoomSound == 3)
				%cl.play2d(Sound_PizzaExplode3);
			
			//award players money everytime they survive a bomb
			if(isObject(%cl.player))
			{
				%cl.score += 40;
				%cl.storedMoney += 40;
			}
		}
		
		//Show message saying who died, and number of survivors left
		%ranDeathMsg = getRandom(1,4);
		if(%ranDeathMsg == 1)
			messageAll( '', "<font:impact:21>\c3 " @ $bomberClient.getPlayerName() @ " \c6has been eliminated. \c3");
		if(%ranDeathMsg == 2)
			messageAll( '', "<font:impact:21>\c3 " @ $bomberClient.getPlayerName() @ " \c6has been annihilated.");
		if(%ranDeathMsg == 3)
			messageAll( '', "<font:impact:21>\c3 " @ $bomberClient.getPlayerName() @ " \c6has been terminated.");
		if(%ranDeathMsg == 4)
			messageAll( '', "<font:impact:21>\c3 " @ $bomberClient.getPlayerName() @ " \c6has been sacrificed to the pizza gods.");
		
		//set new bomb holder
		schedule(5000,0,activateBomb,1);
	}
	else
	{	
		$bombTimerSchedule = schedule(1000,0,bombTimerLoop);
	}
	
}

	//Make bots play confusion and head turn gestures at random times so they appear to be looking for their delivery person
	function botGestureLoop () 
	{
		//echo("DEBUGTEST:  called function botGestureLoop");
		cancel($botGestureSchedule);
		
		//Display helpful info
		$noobHelpCounter += 1;
		if($noobHelpCounter == 25)
		{
			messageAll( '', "<font:impact:21>\c6 Read everything in \c3/help  \c6to receive a bonus! Especially read  \c3/compass");
			$noobHelpCounter = 0;
		}
		
		//Do bot gestures (turn head and use confusion emote - looking for pizza man)
		if($DelivMode == 1 || $DelivMode == 2)
		{
			for(%j = 1; %j <= $PizzaDeliveryGamemodeNumLocations; %j++)
			{
				if($PizzaDeliveryGamemodeLocations[%j].isDeliveryActive == 1 && isObject($PizzaDeliveryGamemodeBots[%j].hbot)) 
				{
					%randomGes1 = getRandom(1,6);
					%randomGes2 = getRandom(1,6);
					%adjustGes1 = %randomGes1 * 1000;
					%adjustGes2 = %randomGes2 * 1000;
					$PizzaDeliveryGamemodeBots[%j].hbot.schedule(adjustGes1,playgesture,7);
					$PizzaDeliveryGamemodeBots[%j].hbot.schedule(adjustGes2,playgesture,17);
				}
			}
		}
		
		//For every player in the minigame...
		%mg = $DefaultMinigame;
		%numAlive = 0;
		%oldTest = 0;
		%newTest = 0;
		for(%i = 0; %i < %mg.numMembers; %i++)
		{
			%client = %mg.member[%i];
			%player = %client.player;
			
			//Update everyone's total playtime on the server
			%client.totalPlaytime = getSimTime() - %client.simTimeAtJoin;
			
			//If someone doesn't have a vehicle spawn yet, respawn them
			if(((%client.hasStartedFirstTimerSchedule != 1 || %client.pervehiclespawn $= "") && $DelivMode != 3) || ((%client.hasStartedFirstTimerSchedule != 1 || %client.pervehiclespawn $= "") && $DelivMode == 3 && getSimTime() - $DefaultMinigame.lastResetTime < 26000))	//lll
			{
				//echo("Someone doesn't have a vehicle and was respawned from 7 second loop");
				%client.alreadySpawned = "";
				%client.hasStartedFirstTimerSchedule = 0;
				%client.spawnPlayer();
			}
			
			if($DelivMode == 3)
			{
				//Get distances of each player from the bomb carrier in an array
				if(isObject($bomberClient.player) && isObject(%client.player) && %client != $bomberClient)
				{
					%numAlive += 1;	
					%dist = mCeil(vectorDist($bomberClient.player.getHackPosition(),%client.player.getHackPosition()));
					$distFromBomber[%numAlive] = %dist;
					$distFromBomberCopy[%numAlive] = %dist;
					$distFromBomberClients[%numAlive] = %client;
					//talk(%client.getPlayerName() @ "  " @ %dist);
					
					%newTest = %dist;
					if(%numAlive == 1)
						%oldTest = %newTest;
					if(%newTest <= %oldTest)
					{
						%oldTest = %newTest;
						$closeHo = %client;
					}
					
				}
				
			}
		}
		
		//for explosive pizza mode, find the closest client to the bomb carrier
		if($DelivMode == 3)
		{	
			if(isObject($bomberClient.player))
				//talk("number alive other than bomb carrier:  " @ %numAlive);
			
			//Sort distances of all players to find the closest to the bomb carrier
			//for(%i = 1; %i < %numAlive; %i++)
			//{
			//	%newTest = $distFromBomber[%i];
			//	if(%i==1)
			//		%oldTest = %newTest;
			//	if(%newTest < %oldTest)
			//	{
			//		%oldTest = %newTest;
			//		%closest = $distFromBomberClients[%i];
			//	}
			//}
			
			//Get the closest client to bomb carrier
			$closeToBomber = $closeHo;
			//talk("Closest player: " @ $closeToBomber.getPlayerName());
			
			//If there's no bomb carrier and the bomb is active, set a new bomb carrier
			if(!isObject($bomberClient.player) && $bombActive == 1 && $somebodyWonPizzaDelivRound = 0)
			{
				$bomberClient = 0;
				while(%cancelWhile != 1)
				{
					%randNum = getRandom(0,$DefaultMinigame.numMembers - 1);
					if(isObject($DefaultMinigame.member[%randNum].player))
					{
						$bomberClient = $DefaultMinigame.member[%randNum];
						%cancelWhile = 1;
					}
				}
			}
		}
		
		$botGestureSchedule = schedule(7000,0,botGestureLoop);
	}


if($pref::Server::SpeedKart::RoundLimit $= "")
{
	//echo("DEBUGTEST:  Speedkart Roundlimit setting to super high number");
   $pref::Server::SpeedKart::RoundLimit = 9999999999999999;
}

$SK::Initialized = false;


function SK_ResetSuicideGambling()
{
	//echo("DEBUGTEST:  function SK_ResetSuicideGambling");
   //scramble the suicide prevention timer, so people can't game it with client scripts
   $SK::SuicideBufferTime = 6000 + getRandom() * 4000;
   //clear suicide gambling winner
   $SK::LastSuicider = 0;

   if(isEventPending($SK::SuicideGamblingEvent))
      cancel($SK::SuicideGamblingEvent);
   $SK::SuicideGamblingEvent = 0;
}

function SK_BuildTrackList()
{
   //echo("DEBUGTEST:  function 2");
   %pattern = "Add-Ons/PizzaDelivery_*/save.bls";
   
   $SK::numTracks = 0;
   
   %file = findFirstFile(%pattern);
   while(%file !$= "")
   {
      $SK::Track[$SK::numTracks] = %file;
      $SK::numTracks++;

      %file = findNextFile(%pattern);
   }
}

function SK_DumpTrackList()
{
	//echo("DEBUGTEST:  function 3");
   echo("");
   if($SK::numTracks == 1)
      echo("1 track");
   else
      echo($SK::numTracks @ " tracks");
   for(%i = 0; %i < $SK::numTracks; %i++)
   {
      %displayName = $SK::Track[%i];
      %displayName = strReplace(%displayName, "Add-Ons/PizzaDelivery_", "");
      %displayName = strReplace(%displayName, "/save.bls", "");
      %displayName = strReplace(%displayName, "_", " ");

      if(%i == $SK::CurrentTrack)
         echo(" >" @ %displayName);
      else
         echo("  " @ %displayName);
   }
   echo("");
}

function SK_NextTrack()
{
	//echo("DEBUGTEST:  function 4");
   $SK::CurrentTrack = mFloor($SK::CurrentTrack);
   $SK::CurrentTrack++;
   $SK::CurrentTrack = $SK::CurrentTrack % $SK::numTracks;

   $SK::ResetCount = 0;

   SK_LoadTrack_Phase1($SK::Track[$SK::CurrentTrack]);
}

function SK_LoadTrack_Phase1(%filename)
{
	//echo("DEBUGTEST:  function 5");
   //suspend minigame resets
   $SK::MapChange = 1;

   //put everyone in observer mode
   %mg = $DefaultMinigame;
   if(!isObject(%mg))
   {
      error("ERROR: SK_LoadTrack( " @ %filename  @ " ) - default minigame does not exist");
      return;
   }
   for(%i = 0; %i < %mg.numMembers; %i++)
   {
      %client = %mg.member[%i];
      %player = %client.player;
      if(isObject(%player))
         %player.delete();

      %camera = %client.camera;
      %camera.setFlyMode();
      %camera.mode = "Observer";
      %client.setControlObject(%camera);
   }
   
   //clear all bricks 
   // note: this function is deferred, so we'll have to set a callback to be triggered when it's done
   BrickGroup_888888.chaindeletecallback = "SK_LoadTrack_Phase2(\"" @ %filename @ "\");";
	BrickGroup_888888.chaindeleteall();
}

function SK_LoadTrack_Phase2(%filename)									//Faraday made new build-load message work for pizza delivery
{
	//echo("DEBUGTEST:  function 6");
   echo("Loading delivery build " @ %filename);

   %displayName = %filename;
   %displayName = strReplace(%displayName, "Add-Ons/PizzaDelivery_", "");				//Faraday changed Speedkart save prefixes to PizzaDelivery
   %displayName = strReplace(%displayName, "/save.bls", "");
   %displayName = strReplace(%displayName, "_", " ");
   
   %loadMsg = "<font:impact:25>\c3 NOW LOADING \c6" @ %displayName;

   //read and display credits file, if it exists
   // limited to one line
   %creditsFilename = filePath(%fileName) @ "/credits.txt";
   if(isFile(%creditsFilename))
   {
      %file = new FileObject();
      %file.openforRead(%creditsFilename);

      %line = %file.readLine();
      %line = stripMLControlChars(%line);
      %loadMsg = %loadMsg @ "<font:impact:25>\c3    CREATED BY \c6" @ %line;

      %file.close();
      %file.delete();
   }

   messageAll('', %loadMsg);

   //load environment if it exists
   %envFile = filePath(%fileName) @ "/environment.txt"; 
   if(isFile(%envFile))
   {  
      //echo("parsing env file " @ %envFile);
      //usage: GameModeGuiServer::ParseGameModeFile(%filename, %append);
      //if %append == 0, all minigame variables will be cleared 
      %res = GameModeGuiServer::ParseGameModeFile(%envFile, 1);

      EnvGuiServer::getIdxFromFilenames();
      EnvGuiServer::SetSimpleMode();

      if(!$EnvGuiServer::SimpleMode)     
      {
         EnvGuiServer::fillAdvancedVarsFromSimple();
         EnvGuiServer::SetAdvancedMode();
      }
   }
   
   //load save file
   schedule(10, 0, serverDirectSaveFileLoad, %fileName, 3, "", 2, 1);
}


//some horrible /commands to change tracks and such
function serverCmdMapList(%client)
{
	//echo("DEBUGTEST:  function 7");
   for(%i = 0; %i < $SK::numTracks; %i++)
   {
      %displayName = $SK::Track[%i];
      %displayName = strReplace(%displayName, "Add-Ons/PizzaDelivery_", "");
      %displayName = strReplace(%displayName, "/save.bls", "");
      %displayName = strReplace(%displayName, "_", " ");

      if(%i == $SK::CurrentTrack)
         messageClient(%client, '', " >" @ %i @ ". \c6" @ %displayName);
      else
         messageClient(%client, '', "  " @ %i @ ". \c6" @ %displayName);
   }
}
function serverCmdSetMap(%client, %i)
{
	//echo("DEBUGTEST:  function 8");
   if(!%client.isAdmin)
      return;

   if(mFloor(%i) !$= %i)
   {
      messageClient(%client, '', "Usage: /setMap <number>");
      return;
   }

   if(%i < 0 || %i > $SK::numTracks)
   {
      messageClient(%client, '', "serverCmdSetMap() - out of range index");
      return;
   }

   messageAll( 'MsgAdminForce', '\c3%1\c2 changed the map', %client.getPlayerName());
   
   $SK::CurrentTrack = %i - 1;
   SK_NextTrack();
}

function serverCmdNextMap(%client, %i)
{
	//echo("DEBUGTEST:  function 9");
   if(!%client.isAdmin)
      return;

   messageAll( 'MsgAdminForce', '\c3%1\c2 switched to the next map', %client.getPlayerName());
   
   SK_NextTrack();
}

function CheckStartClocks(%this)
{
	//echo("DEBUGTEST:  function 10");
	//echo("inside checkstartclocks - Are clocks both at 0? (1 if yes, ones tens): " SPC $ClockOnesBrick.getPrintCount() SPC $ClockTensBrick.getPrintCount());
	if($ClockOnesBrick.getPrintCount() == 0 && $ClockTensBrick.getPrintCount() == 0 && $PizzaDeliveryGamemodeStartingGateBar.isColliding() == 0)		//if true, this means the starting gates have disappeared and the round has started. if false, the clocks are still counting down at the beginning of the round
	{
		%this.perVehicleSpawn.setVehiclePowered(1);
	}
	else
	{
		%this.perVehicleSpawn.setVehiclePowered(0);
		%timeToWait = (($ClockTensBrick.getPrintCount() * 10) + $ClockOnesBrick.getPrintCount())*1000 + 4000;
		%this.perVehicleSpawn.schedule(%timeToWait,setVehiclePowered,1);
	}
}

function skipMusicVoteEndCheck()
{
	//echo("DEBUGTEST:  function 11");
	%mg = $DefaultMinigame;
	for(%i = 0; %i < %mg.numMembers; %i++)
   {
      %client = %mg.member[%i];
      %client.votedSM = 0;
   }	
   if($skipMusicTally != 0)
   {
	   messageAll( '', '<font:impact:21>\c5 The vote to skip music has failed.');
   }  
}

function DecideRoundMusic()
{
	//echo("DEBUGTEST:  function 12");
	//this allows skipmusic voting to happen
	$canSkipMusic = 1;
	
	if($CurrentRoundMusic != "" && $CurrentRoundMusic < 4)	        //MusicRotation
	{
		$CurrentRoundMusic += 1;
	}
	else
	{
		$CurrentRoundMusic = 1;
	}
	
	if(isObject(RoundMusic))
	{
	RoundMusic.schedule(33,"delete");
	}

	if($CurrentRoundMusic == 1)
	{
		new AudioEmitter(RoundMusic)
		{
		position = "0 0 0";
		profile = "musicData_InnerSpace";
		useProfileDescription = "0";
		description = "AudioLooping2D";
		type = "0";
		volume = "3";
		outsideAmbient = "1";
		ReferenceDistance = "4";
		maxDistance = "9001";
		isLooping = "1";
		};		
	}
	else if($CurrentRoundMusic == 2)
	{
		new AudioEmitter(RoundMusic)
		{
		position = "0 0 0";
		profile = "musicData_AllFallDown";
		useProfileDescription = "0";
		description = "AudioLooping2D";
		type = "0";
		volume = "3";
		outsideAmbient = "1";
		ReferenceDistance = "4";
		maxDistance = "9001";
		isLooping = "1";
		};	
	}
	else if($CurrentRoundMusic == 3)
	{
		new AudioEmitter(RoundMusic)
		{
		position = "0 0 0";
		profile = "musicData_CityAtSpeed";
		useProfileDescription = "0";
		description = "AudioLooping2D";
		type = "0";
		volume = "3";
		outsideAmbient = "1";
		ReferenceDistance = "4";
		maxDistance = "9001";
		isLooping = "1";
		};	
	}
	else if($CurrentRoundMusic == 4)
	{
		new AudioEmitter(RoundMusic)
		{
		position = "0 0 0";
		profile = "musicData_FeelGood";
		useProfileDescription = "0";
		description = "AudioLooping2D";
		type = "0";
		volume = "3";
		outsideAmbient = "1";
		ReferenceDistance = "4";
		maxDistance = "9001";
		isLooping = "1";
		};	
	}
}


function FirstTimerSetVehicle(%this,%targetObject)
{
	//echo("DEBUGTEST:  function 13");
	//echo("First timer vehicle function called");
	%this.perVehicleSpawn = %targetObject;
					
	if(!%this.vehicleChoice)
	{
		echo("vehicleChoice not established for " @ %this.bl_id @ ", so spawning bicycle and setting vehicleChoice to bicycle or 1");
		%this.perVehicleSpawn.setVehicle(nameToID(BicycleVehicle));
		%this.vehicleChoice = 1;
	}
	else
	{
		%this.perVehicleSpawn.setVehicle($DeliveryVehicles[%this.vehicleChoice]);		
	}
	%this.perVehicleSpawn.spawnVehicle();
	%this.perVehicleSpawn.setVehiclePowered(0);
	//echo("3 seconds before calling checkstartclocks - Are clocks both at 0? (ones, tens): " SPC $ClockOnesBrick.getPrintCount() SPC $ClockTensBrick.getPrintCount());
	schedule(3000,0,CheckStartClocks,%this);		//check if the starting clocks have already counted down to 0 - this means the round has already started and the vehicle can go
	%this.perVehicleSpawn.vehicle.mountObject(%this.player,0);			
	%this.hasVehicleSpawn = 1;
	%this.alreadySpawned = 1;
}

function NonFirstTimerSetVehicle(%this)
{
	//echo("DEBUGTEST:  function 14");
	//echo("NonFirstTimerSetVehicle Function called");
	%this.perVehicleSpawn.setVehicle($DeliveryVehicles[%this.vehicleChoice]);
	%this.perVehicleSpawn.spawnVehicle();
	%this.perVehicleSpawn.setVehiclePowered(0);
	//echo("3 seconds before calling checkstartclocks - Are clocks both at 0? (ones, tens): " SPC $ClockOnesBrick.getPrintCount() SPC $ClockTensBrick.getPrintCount());
	schedule(3000,0,CheckStartClocks,%this);
	%this.perVehicleSpawn.vehicle.mountObject(%this.player,0);
}

function serverCmdVote(%client, %i)				//tag addgamemode
{
	//echo("DEBUGTEST:  function 15");
	//if the client has not voted...
	if(%client.hasVoted != 1)
	{
		//if client voted for the mode "ONE FOR ONE", increment the ModeVote[1] variable
		if(%i == 1)
		{
			$ModeVote[1] += 1;
			messageAll('', "<font:Impact:21>\c6 " @ %client.name SPC "\c3voted for ONE FOR ONE mode");
			%client.hasVoted = 1;
		}
		//if the client voted for the mode "ONE FOR ALL", increment the ModeVote[2] variable 
		else if(%i == 2)
		{
			$ModeVote[2] += 1;
			messageAll('', "<font:Impact:21>\c6 " @ %client.name SPC "\c3voted for ONE FOR ALL mode");
			%client.hasVoted = 1;
		}
		//if the client voted for the mode "EXPLOSIVE PIZZA", increment the ModeVote[3] variable 
		else if(%i == 3)
		{
			$ModeVote[3] += 1;
			messageAll('', "<font:Impact:21>\c6 " @ %client.name SPC "\c3voted for EXPLOSIVE PIZZA mode");
			%client.hasVoted = 1;
		}
		else
		{
			messageClient(%client, '', "<font:Impact:21>\c5 Invalid response. Example:  /vote 1");
		}
		
	}
	else if(%client.hasVoted == 1) 
		messageClient(%client, '', "<font:Impact:21>\c5 You already voted!");
}



function isOnServer(%client)
{
	//echo("DEBUGTEST:  function 16");
	for(%a=0; %a<clientGroup.getCount(); %a++)
	{
		%cl = clientGroup.getObject(%a);
		if (%cl == %client)
		{
			return 1;
		}
	}
	return 0;
}



//Below is the help menu and most the commands that branch from it
function serverCmdHelp(%client)
{
	//echo("DEBUGTEST:  function 17");
	messageClient(%client, '', "<font:Impact:27>\c3 Help Menu");
	messageClient(%client, '', "<font:Impact:21>\c3 /compass  <font:Impact:20>\c6describes how to use the compass bar.");	//include compass figures and explanation
	messageClient(%client, '', "<font:Impact:21>\c3 /modes  <font:Impact:20>\c6explains the goal of each mode.");	//explain /vote and include win method/description for each mode
	messageClient(%client, '', "<font:Impact:21>\c3 /store  <font:Impact:20>\c6lists the things you can buy.");	//how vehicles are bought with /buy [ vehicle-number ] and list vehicles + prices w/ descriptions
	messageClient(%client, '', "<font:Impact:21>\c3 /stats  <font:Impact:20>\c6shows your stats and stored money.");	//shows your own stats, and tells you that you can do /stats [BLID] to see someone else's stats. Also explain that you can use /money to show your stored bank money
	messageClient(%client, '', "<font:Impact:21>\c3 /stats [ name ]  <font:Impact:20>\c6shows other players' stats.");
	messageClient(%client, '', "<font:Impact:21>\c3 /round  <font:Impact:20>\c6displays current round number and mode.");	//gives round-number / 3. Explains that a new mode is selected after 3rd round based on mode votes. Also tells current mode name.
	messageClient(%client, '', "<font:Impact:21>\c3 /skipmusic  <font:Impact:20>\c6starts vote to skip the current song.");	//starts a vote to skip current song - cooldown of a few minutes
	messageClient(%client, '', "<font:Impact:21>\c3 /mapcommands  <font:Impact:20>\c6provides list of map commands ( admin-only ).");	//provides list of map commands: /maplist,   /setmap,   /nextmap
	
	if(%client.hasReadHelp != 1)
	{
		%client.hasReadHelp = 1;
		%client.storedMoney += 100;
		%client.play2D(Sound_PizzaDeliver);
		messageClient(%client, '', "<font:Impact:21>\c3 You've been awarded $100 for visiting the Help Menu. Please read each section! ( Your stored money is shown in \c6/stats \c3)");
	}
}

	function serverCmdCompass(%client)
	{
		//echo("DEBUGTEST:  function 18");
		//messageClient(%client, '', "<font:arial:40>");
		messageClient(%client, '', "<font:Impact:27>\c3 Compass Guide");
		messageClient(%client, '', "<font:Impact:20>\c6 Find the compass bar at the bottom of your screen ( the grey/blue line ).");
		messageClient(%client, '', "<font:arial:47>\c7 ___\c4_\c7___  <font:Impact:20>\c6If it looks like this, your target is far away because the blue line is short.");
		messageClient(%client, '', "<font:arial:47>\c7 _\c4_____\c7_  <font:Impact:20>\c6If it looks like this, your target is near because the blue line is long.");
		messageClient(%client, '', "<font:arial:47>\c7 ____\c4__\c7_  <font:Impact:20>\c6If it looks like this, your target is to the right because the blue line is positioned on the right of the grey line.");
		messageClient(%client, '', "<font:arial:47>\c7 _\c4__\c7____  <font:Impact:20>\c6If it looks like this, your target is to the left because the blue line is positioned on the left of the grey line.");
		messageClient(%client, '', "<font:arial:47>\c7 _______  <font:Impact:20>\c6If it looks like this, your target is either behind you or very far in front of you.");
		//messageClient(%client, '', "<font:arial:40>");
	}

	function serverCmdModes(%client)
	{
		//echo("DEBUGTEST:  function 19");
		//messageClient(%client, '', "<font:arial:40>");
		messageClient(%client, '', "<font:Impact:27>\c3 Modes Guide");				//tag addgamemode
		messageClient(%client, '', "<font:Impact:20>\c6 To vote for a mode, say /vote [ mode number ]. Example:  /vote 1");
		messageClient(%client, '', "<font:Impact:20>\c3 1.  ONE FOR ONE   \c6All players are assigned their own delivery location. The first to earn $350 wins.");
		messageClient(%client, '', "<font:Impact:20>\c3 2.  ONE FOR ALL   \c6All players are assigned the same delivery location. Only the first to reach each location is awarded. The first to earn $350 wins.");
		messageClient(%client, '', "<font:Impact:20>\c3 3.  EXPLOSIVE PIZZA   \c6A pizza bomb is given to a random player. The bomb must be transferred to another person before it explodes. Last survivor wins. Use Light Key as bomb carrier for a boost.");
		//messageClient(%client, '', "<font:arial:40>");
	}

	function serverCmdStore(%client)
	{
		//echo("DEBUGTEST:  function 20");
		//messageClient(%client, '', "<font:arial:40>");
		messageClient(%client, '', "<font:Impact:27>\c3 Store");
		messageClient(%client, '', "<font:Impact:20>\c6 You have <color:32c132>$" @ %client.storedMoney @ "\c6. To buy an item, say /buy ( item number ). Example:  /buy 1");
		messageClient(%client, '', "<font:Impact:20>\c3 1.  Bicycle                     \c6Price:    <color:32c132>FREE     \c6Speed:  <color:32c132>26    \c6Pizza-Capacity:  <color:32c132>3");
		messageClient(%client, '', "<font:Impact:20>\c3 2.  Velocipede             \c6Price:  <color:32c132>$450     \c6Speed:  <color:32c132>28    \c6Pizza-Capacity:  <color:32c132>3");
		messageClient(%client, '', "<font:Impact:20>\c3 3.  Motor Scooter      \c6Price:  <color:32c132>$800    \c6Speed:  <color:32c132>33    \c6Pizza-Capacity:  <color:32c132>3");
		messageClient(%client, '', "<font:Impact:20>\c3 4.  Delivery Scooter \c6Price:  <color:32c132>$1300    \c6Speed:  <color:32c132>33    \c6Pizza-Capacity:  <color:32c132>4");
		messageClient(%client, '', "<font:Impact:20>\c3 5.  Vespa                       \c6Price:  <color:32c132>$2000    \c6Speed:  <color:32c132>37    \c6Pizza-Capacity:  <color:32c132>4");
		messageClient(%client, '', "<font:Impact:20>\c3 6.  Dirt Bike                  \c6Price:  <color:32c132>$4000    \c6Speed:  <color:32c132>40    \c6Pizza-Capacity:  <color:32c132>4");
		messageClient(%client, '', "<font:Impact:20>\c3 7.  Motorcycle             \c6Price:  <color:32c132>$7500    \c6Speed:  <color:32c132>45    \c6Pizza-Capacity:  <color:32c132>5");
		messageClient(%client, '', "<font:Impact:20>\c3 8. Kei Car S800         \c6Price:  <color:32c132>$9000    \c6Speed:  <color:32c132>48    \c6Pizza-Capacity:  <color:32c132>7");					//tag addvehicle
		messageClient(%client, '', "<font:Impact:20>\c3 Note:  \c6If you want to use a vehicle you have purchased previously, say /vehicle ( item number ). Example:  /vehicle 1");	
		//messageClient(%client, '', "<font:arial:40>");
	}
	
		function serverCmdBuy(%client,%i)				//tag addvehicle
		{
			//echo("DEBUGTEST:  function 21");
			//check for errors in the value entered
			if(mFloor(%i) !$= %i || %i < 1 || %i > 8)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 Invalid response. Example:  /buy 2");
				return;
			}
			//if client wants to buy the free bicycle vehicle (vehicle 1), tell them they can't
			else if (%i == 1)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 The Bicycle is free. " @ ( (%client.vehicleChoice) == 1 ? "" : "If you want to drive it, say /vehicle 1" ));	
				return;
			}
			//if client has already purchased vehicle, tell them to use /vehicle to swap to it
			else if (%i == 2 && %client.hasVehicle2)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You already purchased this vehicle. Say /vehicle " @ %i @ " to use it.");	
				return;
			}
			else if (%i == 3 && %client.hasVehicle3)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You already purchased this vehicle. Say /vehicle " @ %i @ " to use it.");	
				return;
			}
			else if (%i == 4 && %client.hasVehicle4)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You already purchased this vehicle. Say /vehicle " @ %i @ " to use it.");	
				return;
			}
			else if (%i == 5 && %client.hasVehicle5)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You already purchased this vehicle. Say /vehicle " @ %i @ " to use it.");	
				return;
			}
			else if (%i == 6 && %client.hasVehicle6)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You already purchased this vehicle. Say /vehicle " @ %i @ " to use it.");	
				return;
			}
			else if (%i == 7 && %client.hasVehicle7)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You already purchased this vehicle. Say /vehicle " @ %i @ " to use it.");	
				return;
			}
			else if (%i == 8 && %client.hasVehicle8)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You already purchased this vehicle. Say /vehicle " @ %i @ " to use it.");	
				return;
			}
			
			//if player has enough money, update hasVehicle# and vehicleChoice, and subtract vehicle price from client's stored money
			else if (%client.storedMoney >= $DeliveryVehiclePrices[%i])
			{
				%client.storedMoney -= $DeliveryVehiclePrices[%i];
				%client.vehicleChoice = %i;
				
				if (%i == 2)
					%client.hasVehicle2 = 1;
				if (%i == 3)
					%client.hasVehicle3 = 1;
				if (%i == 4)
					%client.hasVehicle4 = 1;
				if (%i == 5)
					%client.hasVehicle5 = 1;
				if (%i == 6)
					%client.hasVehicle6 = 1;
				if (%i == 7)
					%client.hasVehicle7 = 1;
				if (%i == 8)
					%client.hasVehicle8 = 1;
				
				//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
				if(%i >= 1 && %i <= 8 && getSimTime() - $DefaultMinigame.lastResetTime >= 26000)		//tag addvehicle
				{
					messageClient(%client, '', "<font:Impact:21>\c6 Purchase successful! Your new vehicle can be used after this round.");
				}
				//If at the start of the round (before clocks are 0), let the player change vehicle
				else if(%i >= 1 && %i <= 8 && getSimTime() - $DefaultMinigame.lastResetTime < 26000)
				{
					messageClient(%client, '', "<font:Impact:21>\c6 Purchase successful!");
					%client.spawnPlayer();
				}
			}
			else if (%client.storedMoney < $DeliveryVehiclePrices[%i])
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You do not have enough money. It costs \c6$" @ $DeliveryVehiclePrices[%i] @ "\c5 and you have: \c6$" @ %client.storedMoney);
			}
		}
	
		function serverCmdVehicle(%client,%i)			//tag addvehicle
		{
			//echo("DEBUGTEST:  function 22");
			//check for errors in the value entered
			if(mFloor(%i) !$= %i || %i < 1 || %i > 8)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 Invalid response. Example:  /vehicle 1");
				return;
			}
			//if client has purchased vehicle, update their vehicleChoice and respawn the player
			else 
			{
				if(%i == 1)
				{
					//this vehicle is free so don't need to check if client has purchased it
					%client.vehicleChoice = 1;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				
				if(%i == 2 && %client.hasVehicle2 == 1)
				{
					%client.vehicleChoice = 2;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				else if (%i == 2 && !%client.hasVehicle2)
				{
					messageClient(%client, '', "<font:Impact:21>\c5 You have not purchased the Velocipede. To buy it, say /buy 2");
				}
				
				if(%i == 3 && %client.hasVehicle3 == 1)
				{
					%client.vehicleChoice = 3;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				else if (%i == 3 && !%client.hasVehicle3)
				{
					messageClient(%client, '', "<font:Impact:21>\c5 You have not purchased the Motor Scooter. To buy it, say /buy 3");
				}
				
				if(%i == 4 && %client.hasVehicle4 == 1)
				{
					%client.vehicleChoice = 4;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				else if (%i == 4 && !%client.hasVehicle4)
				{
					messageClient(%client, '', "<font:Impact:21>\c5 You have not purchased the Delivery Scooter. To buy it, say /buy 4");
				}
				
				if(%i == 5 && %client.hasVehicle5 == 1)
				{
					%client.vehicleChoice = 5;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				else if (%i == 5 && !%client.hasVehicle5)
				{
					messageClient(%client, '', "<font:Impact:21>\c5 You have not purchased the Vespa. To buy it, say /buy 5");
				}
				
				if(%i == 6 && %client.hasVehicle6 == 1)
				{
					%client.vehicleChoice = 6;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				else if (%i == 6 && !%client.hasVehicle6)
				{
					messageClient(%client, '', "<font:Impact:21>\c5 You have not purchased the Dirt Bike. To buy it, say /buy 6");
				}
				
				if(%i == 7 && %client.hasVehicle7 == 1)
				{
					%client.vehicleChoice = 7;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				else if (%i == 7 && !%client.hasVehicle7)
				{
					messageClient(%client, '', "<font:Impact:21>\c5 You have not purchased the Motorcycle. To buy it, say /buy 7");
				}
				
				if(%i == 8 && %client.hasVehicle8 == 1)
				{
					%client.vehicleChoice = 8;
					
					//if the round has started (countdown clocks are at 0), tell client they must wait until next round to change vehicle
					if(getSimTime() - $DefaultMinigame.lastResetTime >= 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Your vehicle will be changed next round. /vehicle works immediately if used during the inital round countdown.");
					}
					//If at the start of the round (before clocks are 0), let the player change vehicle
					else if(getSimTime() - $DefaultMinigame.lastResetTime < 26000)
					{
						messageClient(%client, '', "<font:Impact:21>\c6 Vehicle change successful!");
						%client.spawnPlayer();
					}
				}
				else if (%i == 8 && !%client.hasVehicle8)
				{
					messageClient(%client, '', "<font:Impact:21>\c5 You have not purchased the Kei Car S800. To buy it, say /buy 8");
				}
			}
			
		}
	
	function serverCmdStats(%client,%i)
	{
		//echo("DEBUGTEST:  function 23");
		//If nothing is entered for i (ex: /stats), show their personal stats
		if (%i == "" && %i $= "")
		{
			if(!%client.storedMoney)
				%client.watchstoredMoney = "0";
			else 
				%client.watchstoredMoney = %client.storedMoney;
			if(!%client.totalDelivs)
				%client.watchtotalDelivs = "0";
			else
				%client.watchtotalDelivs = %client.totalDelivs;
			if(!%client.totalM1Wins)
				%client.watchtotalM1Wins = "0";
			else 
				%client.watchtotalM1Wins = %client.totalM1Wins;
			if(!%client.totalM2Wins)
				%client.watchtotalM2Wins = "0";
			else
				%client.watchtotalM2Wins = %client.totalM2Wins;
			if(!%client.totalM3Wins)
				%client.watchtotalM3Wins = "0";
			else 
				%client.watchtotalM3Wins = %client.totalM3Wins;
			if(!%client.totalPlaytime)
				%client.watchtotalPlaytime = 0;
			else
				%client.watchtotalPlaytime = %client.totalPlaytime;
			if(!%client.totalWins)
				%client.watchtotalWins = "0";
			else 
				%client.watchtotalWins = %client.totalWins;
			if(!%client.highestWinstreak)
				%client.watchhighestWinstreak = "0";
			else
				%client.watchhighestWinstreak = %client.highestWinstreak;
			
			//messageClient(%client, '', "<font:arial:40>");
			messageClient(%client, '', "<font:Impact:27>\c3 Personal Stats");
			messageClient(%client, '', "<font:Impact:20>\c3 Stored Money:   \c6$" @ %client.watchstoredMoney);
			messageClient(%client, '', "<font:Impact:20>\c3 Deliveries:          \c6" @ %client.watchtotalDelivs);
			messageClient(%client, '', "<font:Impact:20>\c3 Playtime:              \c6" @ getTimeString(mCeil(%client.watchtotalPlaytime / 1000)) @ ( (%client.watchtotalPlaytime) >= (3600 * 1000) ? "  ( hr : min : sec )" : "  ( min : sec )" ));
			messageClient(%client, '', "<font:Impact:20>\c3 Wins:                     \c6" @ %client.watchtotalWins);
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 1 Wins:      \c6" @ %client.watchtotalM1Wins);
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 2 Wins:     \c6" @ %client.watchtotalM2Wins);										//tag addgamemode
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 3 Wins:     \c6" @ %client.watchtotalM3Wins);
			messageClient(%client, '', "<font:Impact:20>\c3 Highest Win Streak: \c6" @ %client.watchhighestWinstreak);
			messageClient(%client, '', "<font:Impact:20>\c3 Note:  \c6You can view someone else's stats with /stats [ name ]");
			//messageClient(%client, '', "<font:arial:40>");
			return;
		}
		//if they enetered a name and that person is on the server...
		else if (findclientbyname(%i).bl_id != 0)
		{
			%clientStat = findclientbyname(%i);
			if(!%clientStat.storedMoney)
				%client.seestoredMoney = "0";
			else
				%client.seestoredMoney = %clientStat.storedMoney;
			if(!%clientStat.totalDelivs)
				%client.seetotalDelivs = "0";
			else
				%client.seetotalDelivs = %clientStat.totalDelivs;
			if(!%clientStat.totalM1Wins)
				%client.seetotalM1Wins = "0";
			else
				%client.seetotalM1Wins = %clientStat.totalM1Wins;
			if(!%clientStat.totalM2Wins)
				%client.seetotalM2Wins = "0";
			else
				%client.seetotalM2Wins = %clientStat.totalM2Wins;
			if(!%clientStat.totalM3Wins)
				%client.seetotalM3Wins = "0";
			else
				%client.seetotalM3Wins = %clientStat.totalM3Wins;
			if(!%clientStat.totalPlaytime)
				%client.seetotalPlaytime = 0;
			else 
				%client.seetotalPlaytime = %clientStat.totalPlaytime;
			if(!%clientStat.totalWins)
				%client.seetotalWins = "0";
			else
				%client.seetotalWins = %clientStat.totalWins;
			if(!%clientStat.highestWinstreak)
				%client.seehighestWinstreak = "0";
			else
				%client.seehighestWinstreak = %clientStat.highestWinstreak;
			
			//messageClient(%client, '', "<font:arial:40>");
			messageClient(%client, '', "<font:Impact:27>\c3 Stats Of:  "   @ findclientbyname(%i).name @ " ( " @ findclientbyname(%i).bl_id @ " )");
			messageClient(%client, '', "<font:Impact:20>\c3 Stored Money:   \c6$" @ %client.seestoredMoney);
			messageClient(%client, '', "<font:Impact:20>\c3 Deliveries:          \c6" @ %client.seetotalDelivs);
			messageClient(%client, '', "<font:Impact:20>\c3 Playtime:              \c6" @ getTimeString(mCeil(%client.seetotalPlaytime / 1000)) @ ( (%client.seetotalPlaytime) >= (3600 * 1000) ? "  ( hr : min : sec )" : "  ( min : sec )" ));
			messageClient(%client, '', "<font:Impact:20>\c3 Wins:                     \c6" @ %client.seetotalWins);
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 1 Wins:      \c6" @ %client.seetotalM1Wins);
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 2 Wins:     \c6" @ %client.seetotalM2Wins);										//tag addgamemode
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 3 Wins:     \c6" @ %client.seetotalM3Wins);
			messageClient(%client, '', "<font:Impact:20>\c3 Highest Win Streak: \c6" @ %client.seehighestWinstreak);
			messageClient(%client, '', "<font:Impact:20>\c3 Note:  \c6You can view someone else's stats with /stats [ name ]");
			//messageClient(%client, '', "<font:arial:40>");
			return;
		}
		//if what they entered for i is not a number, show error
		else if(mFloor(%i) !$= %i || %i < 0)
	    {
		  messageClient(%client, '', "<font:Impact:21>\c5 Invalid response. Example:  /stats farad");
		  return;
	    }
		//At this point we know %i is a number, so show the stats for that BLID if it exists. If it doesn't exist, show error.
		else
	    {
			%file = new FileObject();
			%filename = "config/server/persistence/" @ %i @ ".txt";
			%file.openForRead(%filename);

			if(!%file)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 Error:  Did not find server record file in config/server/persistence");
				error("ERROR: Personal stats of BLID: " @ %i @ " - failed to open file '" @ %filename);
				%file.delete();
				return;
			}
			else
			{
			//echo("Loading persistence for BLID " @ %i @ " because " @ %client.name @ " wants to see their stats");
			
			//read and assign data
			  %currObj = 0;
			  %clientInfoFound = 0;
			  while(!%file.isEOF())
			  {
				 %line = %file.readLine();
				 
				 if(%line $= ">CLIENT")
				 {
					%clientInfoFound = 1;
					%currObj = %client;
					continue;
				 }
				 else if(%line $= ">PLAYER")
				 {
					%currObj = %client.player;
					continue;
				 }
				 else if(%line $= ">CAMERA")
				 {
					%currObj = %client.camera;
					continue;
				 }

				 if(!isObject(%currObj))
					continue;

				 %name  = getField (%line, 0);
				 %value = getFields(%line, 1, 999);

				 //special handling of some values
				 if(%name $= "totalWins" && %currObj == %client)
				 {
					%currObj.viewStatTotalWins = %value;
				 }
				 else if(%name $= "storedMoney" && %currObj == %client)
				 {
					%currObj.viewStatStoredMoney = %value;
				 }
				 else if(%name $= "name" && %currObj == %client)
				 {
					%currObj.viewStatName = %value;
				 }
				 else if(%name $= "totalM1Wins" && %currObj == %client)
				 {
					%currObj.viewStatTotalM1Wins = %value;
				 }
				 else if(%name $= "totalM2Wins" && %currObj == %client)
				 {
					%currObj.viewStatTotalM2Wins = %value;
				 }
				else if(%name $= "totalM3Wins" && %currObj == %client)
				 {
					%currObj.viewStatTotalM3Wins = %value;
				 }					 
				 else if(%name $= "totalDelivs" && %currObj == %client)
				 {
					%currObj.viewStatTotalDelivs = %value;
				 }
				 else if(%name $= "totalPlaytime" && %currObj == %client)
				 {
					%currObj.viewStatTotalPlaytime = %value;
				 }
				 else if(%name $= "highestWinstreak" && %currObj == %client)
				 {
					%currObj.viewStathighestWinstreak = %value;
				 }
				 
			  }

			  //close file
			  %file.close();
			  %file.delete();
			
			//if the entered bl_id has no record on the server, notify the client and get out of this function
			if(%clientInfoFound == 0)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 BLID " @ %i @ " has no record on this server.");
				return;
			}
			
			if(!%client.viewStatName)
				%client.viewStatName = "";
			if(!%client.viewStatStoredMoney)
				%client.viewStatStoredMoney = "0";
			if(!%client.viewStatTotalDelivs)
				%client.viewStatTotalDelivs = "0";
			if(!%client.viewStatTotalM1Wins)
				%client.viewStatTotalM1Wins = "0";
			if(!%client.viewStatTotalM2Wins)
				%client.viewStatTotalM2Wins = "0";
			if(!%client.viewStatTotalM3Wins)
				%client.viewStatTotalM3Wins = "0";
			if(!%client.viewStatTotalPlaytime)
				%client.viewStatTotalPlaytime = 0;
			if(!%client.viewStatTotalWins)
				%client.viewStatTotalWins = "0";
			if(!%client.viewStathighestWinstreak)
				%client.viewStathighestWinstreak = "0";
			
			//display stats of blid entered
			messageClient(%client, '', "<font:Impact:27>\c3 Stats of:  " @ %client.viewStatName @ " ( " @ %i @ " )");
			messageClient(%client, '', "<font:Impact:20>\c3 Stored Money:   \c6$" @ %client.viewStatStoredMoney);
			messageClient(%client, '', "<font:Impact:20>\c3 Deliveries:          \c6" @ %client.viewStatTotalDelivs);
			messageClient(%client, '', "<font:Impact:20>\c3 Playtime:              \c6" @ getTimeString(mCeil(%client.viewStatTotalPlaytime / 1000)) @ ( (%client.viewStatTotalPlaytime) >= (3600 * 1000) ? "  ( hr : min : sec )" : "  ( min : sec )" ));
			messageClient(%client, '', "<font:Impact:20>\c3 Wins:                     \c6" @ %client.viewStatTotalWins);
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 1 Wins:      \c6" @ %client.viewStatTotalM1Wins);
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 2 Wins:     \c6" @ %client.viewStatTotalM2Wins);		//tag addgamemode
			messageClient(%client, '', "<font:Impact:20>\c3 Mode 3 Wins:     \c6" @ %client.viewStatTotalM3Wins);
			messageClient(%client, '', "<font:Impact:20>\c3 Highest Win Streak: \c6" @ %client.viewStathighestWinstreak);
			}		
	    }
	}
	
	function serverCmdRound(%client)
	{
		//echo("DEBUGTEST:  function 24");
		//messageClient(%client, '', "<font:arial:40>");
		messageClient(%client, '', "<font:Impact:27>\c3 Current Round Info");
		messageClient(%client, '', "<font:Impact:20>\c3 Playing:   \c6" @ $modeName);	
		messageClient(%client, '', "<font:Impact:20>\c3 Round:     \c6" @ $RoundNum);
		//messageClient(%client, '', "<font:arial:40>");
	}
	
	function serverCmdSkipmusic(%client)
	{
		//echo("DEBUGTEST:  function 25");
		//All of this goes in the servercmdSkipmusic function

		//this prevents music skipping during special times in the server when other music plays (during round start and if someone wins)
		if ($canSkipMusic == 0)
		{
			messageClient(%client,'', "<font:Impact:21>\c5 Music cannot be skipped near round transitions.");
			return;
		}
		
		//don't do anything if the person already voted
		if(%client.votedSM == 1) 
		{ 
			if($skipMusicTally != 0)
			{
				messageClient(%client,'', "<font:Impact:21>\c5 You already voted. " @ (mCeil(0.001*(61000 - (getSimTime() - $skipMusicCooldown)))) @ " seconds until votes are tallied.");
			}
			else
			{
				messageClient(%client,'', "<font:Impact:21>\c5 You must wait \c6" @ (mCeil(0.001*(150000 - (getSimTime() - $skipMusicCooldown)))) @ " \c5seconds to start another 'skipmusic' vote.");
			}		
			return; 
		}
		
		//The voting lasts 1 minute. The cooldown lasts 2+1/2 minutes.
		//if in the first minute after activation, record votes
		if(getSimTime() - $skipMusicCooldown < 60000)
		{
			//echo("someone voted in the voting time");
			%client.votedSM = 1;
			$skipMusicTally += 1;
			if($skipMusicTally == $requiredSMVotes)
			{
				messageAll('', "<font:impact:21>\c5 Successfully skipped music.");
				DecideRoundMusic();
				$skipMusicTally = 0;
			}
			else if ($skipMusicTally > $requiredSMVotes)
			{
				messageClient(%client, '', "<font:Impact:21>\c5 You must wait to start another 'skipmusic' vote.");
				return;
			}
			else if ($skipMusicTally < $requiredSMVotes)
			{
				messageAll( '', "<font:impact:21>\c5 Required /skipmusic votes:  \c6" @ ($requiredSMVotes - $skipMusicTally) @ "\c5 in \c6" @ (mCeil(0.001*(61000 - (getSimTime() - $skipMusicCooldown)))) @ "\c5 seconds.");
			}	
			return;	
		}
		//if after the first minute but before 2.5 minutes after activation, tell ppl they can't activate it yet
		if(getSimTime() - $skipMusicCooldown < 150000)
		{
			//echo("the vote is over but you must wait another minute to do another");
			messageClient(%client, '', "<font:Impact:21>\c5 You must wait \c6" @ (mCeil(0.001*(150000 - (getSimTime() - $skipMusicCooldown)))) @ " \c5seconds to start another 'skipmusic' vote.");
			return;	
		}
		
		//if the cooldown timer has passed, begin a new vote
		$skipMusicTally = 1;
		%client.votedSM = 1;
		if ($DefaultMiniGame.numMembers == 1)
		{
			//echo("1 person in mini - skipped music");
			DecideRoundMusic();
			messageAll( '', "<font:impact:21>\c6 " @ %client.getPlayerName() @ " \c5skipped the current music.");
			$skipMusicTally = 0;
		}
		else if ($DefaultMiniGame.numMembers < 4)
		{
			//echo("Less than 4 people in mini - 2 votes needed to skip music");
			$requiredSMVotes = 2;
			messageAll( '', "<font:impact:21>\c6 " @ %client.getPlayerName() @ " \c5started a vote to skip the music. Required /skipmusic votes:  \c6" @ $requiredSMVotes - 1);
		}
		else
		{
			$requiredSMVotes = mCeil($DefaultMiniGame.numMembers * 0.3);
			//echo("Over 4 people in mini - " @ $requiredSMVotes @ " votes needed to skip music");
			messageAll( '', "<font:impact:21>\c6 " @ %client.getPlayerName() @ " \c5started a vote to skip the music. Required /skipmusic votes: \c6" @ $requiredSMVotes - 1);
		}
		schedule(61000,0,skipMusicVoteEndCheck);	//schedule endvote check 61 s - reset %client.votedSM - if vote tally != 0 display that the vote failed - bc if the vote succeeded, it would have already happened
		$skipMusicCooldown = getSimTime();
		return;
	}

	
function serverCmdMapcommands(%client)
{
	//echo("DEBUGTEST:  function 26");
	//messageClient(%client, '', "<font:arial:40>");
	messageClient(%client, '', "<font:Impact:27>\c3 Map Commands List");
	messageClient(%client, '', "<font:Impact:21>\c3 /maplist  <font:Impact:20>\c6lists all available maps.");
	messageClient(%client, '', "<font:Impact:21>\c3 /setmap [ map number ]  <font:Impact:20>\c6( ADMIN-ONLY ) changes to a specific map ( see corresponding numbers in /maplist ).");
	messageClient(%client, '', "<font:Impact:21>\c3 /nextmap  <font:Impact:20>\c6( ADMIN-ONLY ) changes to the next map.");
	//messageClient(%client, '', "<font:arial:40>");
}



function resetPizzaCount()
{
	//echo("DEBUGTEST:  function 27k");
	for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
	{
		%this = $DefaultMinigame.member[%i];

		//Give max capacity of pizza that their vehicle can carry
		if(!%this.vehicleChoice || %this.vehicleChoice == 1 || %this.vehicleChoice == 2 || %this.vehicleChoice == 3)	//tag addvehicle
		{
			%this.pizzaCount = 3;
		}
		else if(%this.vehicleChoice == 4 || %this.vehicleChoice == 5 || %this.vehicleChoice == 6)
		{
			%this.pizzaCount = 4;
		}
		else if(%this.vehicleChoice == 7)
		{
			%this.pizzaCount = 5;
		}
		else if(%this.vehicleChoice == 8)
		{
			%this.pizzaCount = 7;
		}
	}
}


function servercmdColor(%client,%color)
{	
	//echo("DEBUGTEST:  function 27j");
	if(isObject(%client.perVehicleSpawn))
	{
		if(mFloor(%color) !$= %color || %color < 0 || %color > 62)
			messageClient(%client, '', "<font:Impact:21>\c5 The number must be from 0 - 62. Example:  /color 7");
		else	
			%client.perVehicleSpawn.setColor(%color);
	}
}




package GameModePizzaDeliveryPackage
{
	//Don't allow players to dismount their vehicles during the round start or right after they spawn
	function armor::doDismount(%db,%pl,%force)
	{
		if(getSimTime() - $DefaultMinigame.lastResetTime < 26000 || getSimTime() - %pl.client.lastSpawnTime < 3000)
			return;
		return parent::doDismount(%db,%pl,%force);
	}
	
	//Don't allow players to wear stuff on their back (backpack, quiver, etc)
	function serverCmdupdateBodyParts(%client, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l)
	{
		//echo("DEBUGTEST:  function 27i");
		  parent::serverCmdupdateBodyParts(%client, %a, %b, "0", %d, %e, %f, %g, %h, %i, %j, %k, %l);
	}
	
	//When someone leaves minigame but not server...
	function serverCmdLeaveMinigame(%client)
	{
		if($DelivMode == 3 && %client == $bomberClient && $bomberGoneDetect == 0)
		{
			$bomberGoneDetect = 1;
			cancel($bombTimerSchedule);
			$bombActive = 0;
			schedule(3000,0,activateBomb,1);
		}
		
		parent::serverCmdLeaveMinigame(%client);
	}
	
	//When someone leaves the server...
	function gameConnection::onClientLeaveGame(%client)
	{
		if($DelivMode == 3 && %client == $bomberClient && $bomberGoneDetect == 0)
		{
			$bomberGoneDetect = 1;
			cancel($bombTimerSchedule);
			$bombActive = 0;
			schedule(3000,0,activateBomb,1);
		}
	  parent::onClientLeaveGame(%client);
	}
	
	//vehicles should explode in water for Mode 3
   function VehicleData::onEnterLiquid(%data, %obj, %coverage, %type)
	{
		//echo("DEBUGTEST:  function 27g");
		Parent::onEnterLiquid(%data, %obj, %coverage, %type);
		if($DelivMode == 3)
		{
			%client = %obj.getControllingClient();
			%obj.damage(%obj, %obj.getPosition(), 10000, $DamageType::Lava);
			%obj.spawnExplosion(tankShellProjectile,0.8);
			%client.player.kill();
		}
	}
   
   //players should die in water, mode 3
	function Armor::onEnterLiquid(%data, %obj, %coverage, %type)
	{		
		Parent::onEnterLiquid(%data, %obj, %coverage, %type);
		if($DelivMode == 3)
		{
			%obj.hasShotOnce = true;
			%obj.invulnerable = false;
			%obj.damage(%obj, %obj.getPosition(), 10000, $DamageType::Lava);
			messageClient(%obj.client, '', "<font:Impact:21>\c5 Water is dangerous in this mode. This prevents cheating. Be careful!");
		}
	}

	//Vehicle boost - for bomb carriers (mode 3) or possibly special rounds or for quick deliveries (modes 1+2)
	function servercmdLight(%client)
	{	
		//echo("DEBUGTEST:  function 27f");
		if(%client == $bomberClient)
		{
			if(isObject(%client.player.getControlObject()))
			{
					%vehicle = %client.player.getControlObject();
					if(getSimTime() - %client.boostCooldown < 1000 || !%vehicle.getWheelPowered(2))
					{
							return;						//If you want to tell how many seconds left until recharging is done, use this: (mCeil(0.001*(4000 - (getSimTime() - %Client.boostCooldown))))
					}
					%veh = %client.player.getControlObject();
					%veh.setVelocity(vectorAdd(%veh.getVelocity(),vectorScale(%veh.getForwardVector(),27)));
					%client.player.spawnExplosion(playerTeleportProjectile, 0.6);
					serverPlay3D(boost3Sound,%client.player.gethackposition());
					%client.boostCooldown = getSimTime();
				  return;
			}
		}
	}
	
	//Make someone win mode 3 if there's 1 survivor
	function MiniGameSO::checkLastManStanding(%this, %client)
	{
		//echo("DEBUGTEST:  function 27e");
		if($DelivMode == 3)
		{
			%numAlive = 0;
			for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
			{
				%cl = $DefaultMinigame.member[%i];
				if(isObject(%cl.player))
				{
					%numAlive += 1;
					$lastClientM3 = %cl;
				}
					
			}
			if(%numAlive == 1 && $lastClientM3.alreadyWon != 1 && $somebodyWonPizzaDelivRound != 1 && getSimTime() - $DefaultMinigame.lastResetTime > 36000)
			{
				$lastClientM3.alreadyWon = 1;
				$somebodyWonPizzaDelivRound = 1;
				$lastClientM3.winRace();
				cancel($bombTimerSchedule);
			}
		}
	
    Parent::checkLastManStanding(%this, %client);
  }
	
	
	
	//Delete bottomprint message "# Observers"
	function SimObject::onCameraEnterOrbit(%obj, %camera) 
	{
		//echo("DEBUGTEST:  function 27c");
	}
	function SimObject::onCameraLeaveOrbit(%obj, %camera) 
	{
		//echo("DEBUGTEST:  function 27d");
	}
	
	
	//Don't allow players to respawn in Mode 3. Instead, let them spectate other players who are alive
	function Observer::onTrigger(%this,%cam,%btn,%state)
	{
		//echo("DEBUGTEST:  function 27b");
		if($DelivMode == 3)
		{
			%client = %cam.getControllingClient();
			
			if(%client.isSpectator != 1)
				return;
		
			if(%state == 1)
			{
				
				%c = $DefaultMinigame.numMembers;
				%aliveCount = 0;
				for(%i = 0; %i < %c; %i++)
				{
					%member = $DefaultMinigame.member[%i];

					if(!isObject(%member.player)) continue;
					
					%aliveCount += 1;
					%livingList[%aliveCount] = %member;
				}

				//talk("observingClient: " @ %client.observingClient);
				
				if(%aliveCount >= 1)
				{
					//talk("aliveCount >= 1");
					if(!%client.observingClient)
					{
						//talk("clicker has no predefined observer - set player 1");
						%client.observingClient = 1;
						%client.camera.setOrbitMode(%livingList[1].player, %livingList[1].player.getTransform(), 0.5, 10, 20, false);
						%client.setControlObject(%client.camera);
					}
					else
					{
						%client.observingClient += 1;
						if(%client.observingClient > %aliveCount)
						{
							//talk("clicker has a predefined observer >> but it was the last player - set player 1");
							%client.observingClient = 1;
							%client.camera.setOrbitMode(%livingList[1].player, %livingList[1].player.getTransform(), 0.5, 10, 20, false);
							%client.setControlObject(%client.camera);
						}
						else
						{
							//talk("clicker has a predefined observer >> set to next player");
							%client.camera.setOrbitMode(%livingList[%client.observingClient].player, %livingList[%client.observingClient].player.getTransform(), 0.5, 10, 20, false);
							%client.setControlObject(%client.camera);
						}
					}
				}	
			}
			
			return;
		}
		
		parent::onTrigger(%this,%cam,%btn,%state);
	}
	
	
	//Prevent centerprint "Click to Respawn" after dying in Mode 3
	function gameConnection::onDeath(%cl,%sourceObject,%sourceClient,%damageType,%damageArea)
	{
		//echo("DEBUGTEST:  function 27a");
		parent::onDeath(%cl,%sourceObject,%sourceClient,%damageType,%damageArea);
		
		%cl.isSpectator = 1;
		//Prevent centerprint "Click to Respawn" after dying in Mode 3
		if($DelivMode == 3)
		{
			messageClient(%cl,'MsgYourSpawn');
			centerPrint(%cl,"",1);
		}
		//Set new bomber if bomber dies in mode 3
		if($DelivMode == 3 && %cl == $bomberClient && $bomberGoneDetect == 0)
		{
			$bomberGoneDetect = 1;
			cancel($bombTimerSchedule);
			$bombActive = 0;
			schedule(3000,0,activateBomb,1);
		}
	}
	
	//Whenever someone joins the server, check the time so that their total playtime can be recorded
	function gameConnection::AutoAdminCheck(%client)
	{
		//echo("DEBUGTEST:  simTime at join defined");
        //check if client has any persistence variables saved from previous time on server
		%client.simTimeAtJoin = getSimTime();
		//echo(%client.getPlayerName() @ "  simtimeAtJoin:  " @ getSimTime());
		return parent::AutoAdminCheck(%client);
	}
	
	
	//this prevents players from picking up the pizzabox item and having it in their inventory
	function pizzaItem::onPickUp(%this,%item,%pl,%a)
	{
		//echo("DEBUGTEST:  function 27");
		return;
	}
	
	//this prevents bots from mounting vehicles	
	function minigameCanUse(%objA, %objB)
	{
		//echo("DEBUGTEST:  function 28");
		if(isObject(%objA) && isObject(%objB))
		{
			if(%objA.getClassName() $= "AIPlayer" && (%objB.getClassName() $= "WheeledVehicle" || %objB.getClassName() $= "FlyingVehicle" || %objB.getClassName() $= "AIPlayer" && %objB.getDataBlock().rideable))
			{
					return 0;
			}

			if(%objB.getClassName() $= "AIPlayer" && (%objA.getClassName() $= "WheeledVehicle" || %objA.getClassName() $= "FlyingVehicle" || %objA.getClassName() $= "AIPlayer" && %objA.getDataBlock().rideable))
			{
					return 0;
			}
		}

		parent::minigameCanUse(%objA, %objB);
	}

   //this starts the compass loop when the minigame is first added/started
   function MinigameSO::onAdd(%this)
   {
	   //echo("DEBUGTEST:  function 29");
        parent::onAdd(%this);
        compassLoop();
		botGestureLoop();

	//DEFINE THE VEHICLES BEING USED (IF YOU WANT TO USE DIFFERENT # OF OR DIFFERENT VEHICLES			tag addvehicle NOTE: Also update EventZonesServer.cs at this tag location
	$DeliveryVehicles[1] = nameToID(BicycleVehicle);
	$DeliveryVehicles[2] = nameToID(VelocipedeVehicle);
	$DeliveryVehicles[3] = nameToID(ScooterVehicle);
	$DeliveryVehicles[4] = nameToID(DeliveryVehicle);
	$DeliveryVehicles[5] = nameToID(VespaVehicle);
	$DeliveryVehicles[6] = nameToID(DirtBikeVehicle);
	$DeliveryVehicles[7] = nameToID(MotorcycleVehicle);
	$DeliveryVehicles[8] = nameToID(KeiCarSS800Vehicle);
	
	//DEFINE PRICES OF EACH VEHICLE				tag addvehicle
	$DeliveryVehiclePrices[1] = 0;
	$DeliveryVehiclePrices[2] = 450;
	$DeliveryVehiclePrices[3] = 800;
	$DeliveryVehiclePrices[4] = 1300;
	$DeliveryVehiclePrices[5] = 2000;
	$DeliveryVehiclePrices[6] = 4000;
	$DeliveryVehiclePrices[7] = 7500;
	$DeliveryVehiclePrices[8] = 9000;

	$RoundNum = 0;
	$DelivMode = 1;
	$ModeVote[1] = 0;
	$ModeVote[2] = 0;		//tag addgamemode
	$ModeVote[3] = 0;
	
	DecideRoundMusic();
   }
   
   //this makes the pizza box item rotate, to make it obviously a pickup!
   function PizzaItem::onAdd(%this, %obj)
   {
	//echo("DEBUGTEST:  function 30");
	%obj.rotate = true;
	Parent::onAdd(%this, %obj);
   }

   //this is called when save loading finishes 
   function GameModeInitialResetCheck()
   {
	  //echo("DEBUGTEST:  function 31");
      Parent::GameModeInitialResetCheck();

      //if there is no track list, attempt to create it
      if($SK::numTracks == 0)
         SK_BuildTrackList();
      
      //if tracklist is still empty, there are no tracks
      if($SK::numTracks == 0)
      {
         messageAll('', "\c5No maps available!");
         return;
      }

      if($SK::Initialized)
         return;

      $SK::Initialized = true;
      $SK::CurrentTrack = -1;
            
      SK_NextTrack();
   }

   //when we're done loading a new track, reset the minigame
   function ServerLoadSaveFile_End()
   {
	  //echo("DEBUGTEST:  function 32");
      Parent::ServerLoadSaveFile_End();

      //new track has loaded, reset minigame
      if($DefaultMiniGame.numMembers > 0) //don't bother if no one is here (this also prevents starting at round 2 on server creation)
         $DefaultMiniGame.scheduleReset(); //don't do it instantly, to give people a little bit of time to ghost

      SK_ResetSuicideGambling();

	//Faraday - after bricks are loaded, we need to put all of the delivery location brick object ID's into a global variable - they will be used many times throughout this script
		findImportantBricks();

   }
   

   function findImportantBricks()
   {
	   //echo("DEBUGTEST:  function 33");
	    messageAll('', "<font:Impact:20>\c6 Beginning important brick search...");
		%counter = 1;
		%counterP = 1;
		%counterV = 1;
		%foundStartingGateBar = 0;
		%mainBrickGroupCnt = mainBrickGroup.getCount();
		for(%i = 0; %i < %mainBrickGroupCnt; %i++) 
		{
			%brickGroup = mainBrickGroup.getObject(%i);
			%brickGroupCnt = %brickGroup.getCount();
			for(%j = %brickGroupCnt-1; %j > 0; %j--) 
			{
				%brick = %brickGroup.getObject(%j);
				%brickname = %brick.getname();
				//Get the objectid of all of the delivery locations 
				if(getSubStr(%brickname,0,6) $= "_deliv")
				{
					$PizzaDeliveryGamemodeLocations[getSubStr(%brickname,6,2)] = %brick;
					//The below array reverses the indexes and values from the above array. This is used when we have the value of the above array and we need its index. See implementation at tag: 'UsingReverseArray' in EventZonesServer.cs
					$PizzaDeliveryGamemodeLocationsReverse[%brick] = getSubStr(%brickname,6,2);
					$PizzaDeliveryGamemodeLocations[getSubStr(%brickname,6,2)].isDeliveryActive = 0;
					echo("Delivery Location ObjID " @ getSubStr(%brickname,6,2) @ ":  " @ $PizzaDeliveryGamemodeLocations[getSubStr(%brickname,6,2)]);
					%counter += 1;
				}
				//Get the objectid of the pizza zone bricks
				if(getSubStr(%brickname,0,6) $= "_pizza")
				{
					$PizzaDeliveryGamemodePizzaLocations[%counterP] = %brick;	
					$PizzaDeliveryGamemodePizzaLocation = $PizzaDeliveryGamemodePizzaLocations[1];
					echo("Pizza Zone Location ObjID " @ %counterP @ ":  " @ $PizzaDeliveryGamemodePizzaLocation);
					%counterP += 1;
				}
				//Get the objectid of the first starting gate brick found
				if(getSubStr(%brickname,0,16) $= "_startingGateBar" && %foundStartingGateBar == 0)
				{
					$PizzaDeliveryGamemodeStartingGateBar = %brick;
					echo("Starting Gate Bar ObjID:  " @ $PizzaDeliveryGamemodeStartingGateBar);
					%foundStartingGateBar = 1;		
				}
				//Match all the pizza delivery locations with their respective bot holes
				if(getSubStr(%brickname,0,4) $= "_bot")
				{
					$PizzaDeliveryGamemodeBots[getSubStr(%brickname,4,2)] = %brick;
					echo("BotHole ObjID " @ getSubStr(%brickname,4,2) @ ":  " @ $PizzaDeliveryGamemodeBots[getSubStr(%brickname,4,2)]);
				}
				//Get the objectid of a clockTens brick
				if(getSubStr(%brickname,0,10) $= "_clockTens" && $ClockTensBrick == "")
				{
					$ClockTensBrick = %brick;
					echo("Clock Tens ObjID:  " @ %brick);
				}
				//Get the objectid of a clockOnes brick
				if(getSubStr(%brickname,0,10) $= "_clockOnes" && $ClockOnesBrick == "")
				{
					$ClockOnesBrick = %brick;
					echo("Clock Ones ObjID:  " @ %brick);	
				}
				//Get objectid of all vehicle spawns
				if(getSubStr(%brickname,0,13) $= "_vehicleSpawn")
				{
					$VehicleSpawnBricks[%counterV] = %brick;	
					%counterV += 1;
				}			
				
				//Tell everyone when this function finishes, and if there were any errors (it checks for errors by seeing if the newly defined variables are objects)
				if(%j == 1)
				{
					messageAll('', "<font:Impact:20>\c6 Finishing important brick search...");
					messageAll('', "<font:Impact:20>\c6 Reference %i:  " @ %i);
					if(isobject($ClockTensBrick) == 0 || isobject($ClockOnesBrick) == 0)
					{
						messageAll('', "<font:Impact:20> \c5Error: Missing $clockOnes and/or $clockTens");
					}
					else { messageAll('', "<font:Impact:20> \c2 Found: $clockOnes and/or $clockTens"); }
	
					if(isobject($PizzaDeliveryGamemodePizzaLocation) == 0)
					{
						messageAll('', "<font:Impact:20> \c5Error: Missing $PizzaDeliveryGamemodePizzaLocation");
					}
					else { messageAll('', "<font:Impact:20> \c2 Found: $PizzaDeliveryGamemodePizzaLocation"); }
					
					if(isobject($PizzaDeliveryGamemodeStartingGateBar) == 0)
					{
						messageAll('', "<font:Impact:20> \c5Error: Missing $PizzaDeliveryGamemodeStartingGateBar");
					}
					else { messageAll('', "<font:Impact:20> \c2 Found: $PizzaDeliveryGamemodeStartingGateBar"); }
					
					%q1 = 0;
					%q2 = 0;
					%q3 = 0;
					%cnt = 1;
					while(%q1 == 0 && q2 == 0 && q3 == 0)
					{
						if((isobject($PizzaDeliveryGamemodeLocations[%cnt]) == 0) && %q1 == 0)
						{
							%q1 = 1;
							if(%cnt > 1)
							{
								%realcnt = %cnt - 1;
								messageAll('', "<font:Impact:20> \c2 Found: $PizzaDeliveryGamemodeLocations -  " @ %realcnt @ " total");
							}
							else
							{
								messageAll('', "<font:Impact:20> \c5Error: Missing $PizzaDeliveryGamemodeLocations");
							}
						}
						if((isobject($PizzaDeliveryGamemodeBots[%cnt]) == 0) && %q2 == 0)
						{
							%q2 = 1;
							if(%cnt > 1)
							{
								%realcnt = %cnt - 1;
								messageAll('', "<font:Impact:20> \c2 Found: $PizzaDeliveryGamemodeBots -  " @ %realcnt @ " total");
							}
							else
							{
								messageAll('', "<font:Impact:20> \c5Error: Missing $PizzaDeliveryGamemodeBots");
							}
						}
						if((isobject($VehicleSpawnBricks[%cnt]) == 0) && %q3 == 0)
						{
							%q3 = 1;
							if(%cnt > 1)
							{
								%realcnt = %cnt - 1;
								messageAll('', "<font:Impact:20> \c2 Found: $VehicleSpawnBricks -  " @ %realcnt @ " total");
							}
							else
							{
								messageAll('', "<font:Impact:20> \c5Error: Missing $VehicleSpawnBricks");
							}
						}
						%cnt += 1;
					}
				}
			}
		}	
		$PizzaDeliveryGamemodeNumLocations = %counter - 1;
		$NumPizzaLocations = %counterP - 1;
   }
   
   
   
   //when vehicle spawns, it cannot move (event must enable it)
   //this solves the driving through the garage problem
   //function WheeledVehicleData::onAdd(%data,%obj)
   //{
   //   Parent::onAdd(%data, %obj);

   //   for(%i = 0; %i < %data.numWheels; %i++)
   //      %obj.setWheelPowered(%i, %on);
   //}

   //also you cannot click-push a vehicle while it is in non-moving mode
   function vehicle::OnActivate(%vehicle, %activatingObj, %activatingClient, %pos, %vec)
   {
	   //echo("DEBUGTEST:  function 34");
      //just check a wheel
      if(!%vehicle.getWheelPowered(2))
         return;

      Parent::OnActivate(%vehicle, %activatingObj, %activatingClient, %pos, %vec);
   }

   function SK_SuicideGamblingCheck()
   {
	   //echo("DEBUGTEST:  function 35");
      //check for duplicate schedules
      if(isEventPending($SK::SuicideGambleEvent))  
         cancel($SK::SuicideGambleEvent);
      $SK::SuicideGambleEvent = 0;

      if(!isObject($SK::LastSuicider))
         return;

      if($SK::LastSuicider.getClassName() !$= "GameConnection")
         return;
      
      %player = $SK::LastSuicider.player;
      if(!isObject(%player))
         return;

      //last suicider is valid, give them a win emote
      %player.emote(winStarProjectile, 1);
      %player.playAudio(0, rewardSound);
   }

   //if you kill yourself in a vehicle, kill the vehicle
   function serverCmdSuicide(%client)
   {
		//echo("DEBUGTEST:  function 36");
		%player = %client.player;
		if(!isObject(%player))
			return;
		
		if(getSimTime() - $DefaultMinigame.lastResetTime > 40000 && $somebodyWonPizzaDelivRound == 0 && %client != $bomberClient)
			%player.kill();
		else if(!(getSimTime() - $DefaultMinigame.lastResetTime > 40000))
			messageClient(%client, '', "<font:Impact:21>\c5 You cannot use suicide near round transitions. Wait " @ mCeil((40000 - (getSimTime() - $DefaultMinigame.lastResetTime))/1000) @ " seconds.");
		else if(%client == $bomberClient)
			messageClient(%client, '', "<font:Impact:21>\c5 You cannot use suicide as the bomb carrier.");	
   }
      
   //resume death animation after corpse is booted out of burning vehicle
   function Armor::onUnmount(%data, %obj, %slot)
   {
	   //echo("DEBUGTEST:  function 37");
      Parent::onUnmount(%data, %obj, %slot);

      if(%obj.getDamagePercent() >= 1)
      {
         %obj.playthread(3, "death1");
      }
   }
   
   //if smoeone gets back into a garage after the game starts, we don't want them to be able to press a button and respawn someone's cart from under them
   function fxDTSBrick::setVehicle(%obj, %data, %client)
   {
	   //echo("DEBUGTEST:  function 38");
      if(isObject(%obj.vehicle))
      {
         //vehicle exists, if it is far from spawn, don't do this event
         %vec = vectorSub(%obj.vehicle.getPosition(), %obj.getPosition());
         %dist = vectorLen(%vec);
         if(%dist > 10)
         {
            return;
         }
      }

      Parent::setVehicle(%obj, %data, %client);
   }
   
   //total hack: when a vehicle is turned on record the start-of-race time
   // other options would be to make another event or add in a time offset 
   function fxDTSBrick::setVehiclePowered(%obj, %on, %client)
   {
	   //echo("DEBUGTEST:  function 39");
      Parent::setVehiclePowered(%obj, %on, %client);

      if(%on)
      {
         if(isObject($DefaultMiniGame))
         {
            if($DefaultMiniGame.raceStartTime <= 0)
               $DefaultMiniGame.raceStartTime = getSimTime();
         }
      }
   }
	
	//tag: minireset .. minigamereset
    function MiniGameSO::Reset(%obj, %client)
	{
		//echo("DEBUGTEST:  function 40");
		  //make sure this value is an number
		  $pref::Server::SpeedKart::RoundLimit = mFloor($pref::Server::SpeedKart::RoundLimit);

		  //handle our race time hack
		  %obj.raceStartTime = 0;

		  //count number of minigame resets, when we reach the limit, go to next track
		  if(%obj.numMembers >= 0 && $SK::ResetCount < $pref::Server::SpeedKart::RoundLimit - 1)	//Faraday - Added the && blahblah so that the build never switches, since we only have 1 map currently
		  {
			 $SK::ResetCount++;
		  }

		  if($SK::ResetCount > $pref::Server::SpeedKart::RoundLimit)			
		  {
			 $SK::ResetCount = 0;
			 SK_NextTrack();
		  }
		  else
		  {
			 Parent::Reset(%obj, %client);
		  }

		  SK_ResetSuicideGambling();
		

		
		//save important variables to config/server/persistence (stored money, total deliveries, purchases, etc)
		 saveAllClientPersistence();
		
		
		//if for some reason the important bricks like clockOnes become undefined, re-define them (this has actually been a problem. Not sure what causes it)
		if(isobject($ClockTensBrick) == 0 || isobject($ClockOnesBrick) == 0 || isobject($PizzaDeliveryGamemodeLocations[1]) == 0 || isobject($PizzaDeliveryGamemodePizzaLocation) == 0 || isobject($PizzaDeliveryGamemodeBots[1]) == 0 || isobject($VehicleSpawnBricks[1]) == 0)
		{
			messageAll('', "<font:Impact:24> \c5Error: Missing variables for important bricks");
			findImportantBricks();
		}
		
		if(isObject(RoundMusic))
		{
			RoundMusic.schedule(33,"delete");
			$canSkipMusic = 0;		//prevents music skipping while the round is starting
		}

		new AudioEmitter(RoundStartMusic)
		{
			position = "0 0 0";
			profile = "musicData_MarioKartStart";
			useProfileDescription = "0";
			description = "AudioLooping2D";
			type = "0";
			volume = "1";
			outsideAmbient = "1";
			ReferenceDistance = "4";
			maxDistance = "9001";
			isLooping = "0";
		};
		RoundStartMusic.schedule(26000,"delete");
		
		schedule(25500,0,DecideRoundMusic);

		//Vehicle rotation mechanism - this was removed when I updated the gamemode to allow vehicle purchasing in the store
		//if($currentVehicleRotation != "" && $currentVehicleRotation < 5)		//vehRotation
		//{
		//	$currentVehicleRotation = $currentVehicleRotation + 1;
		//}
		//else		
		//{
		//	$currentVehicleRotation = 1;
		//}
		
		//Increment round number when minigame resets
		if(%obj.numMembers >= 0)
		{
			$RoundNum += 1;
		}
		
		
		if($RoundNum > 1) //changed from 3 to 1 so votes go into effect after every round
		{
			//Reset $somebodyWonPizzaDelivRound
			$somebodyWonPizzaDelivRound = 0;
			
			messageAll('', "<font:Impact:29>\c3 Voting Results");			
			messageAll('', "<font:Impact:24>\c3 ONE FOR ONE  -  \c6" @ $ModeVote[1]);
			messageAll('', "<font:Impact:24>\c3 ONE FOR ALL  -  \c6" @ $ModeVote[2]);
			messageAll('', "<font:Impact:24>\c3 EXPLOSIVE PIZZA  -  \c6" @ $ModeVote[3]);			//tag addgamemode
			
			%numModes = 3;			//tag addgamemode
			
			//If all mode votes are tied, pick random. Otherwise, choose the highest voted.
			if($ModeVote[1] == $ModeVote[2] && $ModeVote[2] == $ModeVote[3])
			{
					echo("---------- ALL VOTES TIED - PICK RANDOM");
					%randomModeNum = getRandom(1,%numModes);
					$DelivMode = %randomModeNum;
			}
			else
			{
				echo("---------- VOTES NOT TIED - PICK HIGHEST COUNT");
				//make copy of ModeVote so that we know which modes go with which number of votes after sorting ModeVote
				for( %q = 1; %q <= %numModes; %q++ )		
				{
					%ModeVoteCopy[%q] = $ModeVote[%q];
					//echo("ModeVoteCopy[" @ %q @ "] = " @ $ModeVote[%q]);
				}
				
				//sort array ModeVote of length numModes (the last element in the sorted array is the greatest)
				%i = 0;
				%j = 0;
				%temp = 0;
				for( %i = %numModes; %i >= 0; %i-- )  
				{  
					for( %j = 1; %j <= %i; %j++ )  
					{  
						if( $ModeVote[%j-1] > $ModeVote[%j] )  
						{  
							%temp = $ModeVote[%j-1];  
							$ModeVote[%j-1] = $ModeVote[%j];  
							$ModeVote[%j] = %temp;  
						}  
					}  
				}
				
				//compare sorted ModeVote to its unsorted copy to determine which mode has the most votes
				for( %k = 1; %k <= %numModes; %k++ )		
				{
					if($ModeVote[%numModes] == %ModeVoteCopy[%k])
					{
						echo("---------- HIGHEST COUNT WAS FOR MODE" @ %k);
						$DelivMode = %k;
					}
					//echo("ModeVoteSorted[" @ %k @ "] = " @ $ModeVote[%k]);
				}
			}
			
			//Change the mode under certain conditions (ie not enough players)
			if(($DelivMode == 2 || $DelivMode == 3) && $DefaultMiniGame.numMembers < 2) 		//tag addgamemode if it requires at least 2 people (put || in the if and while statements and the number of the new mode)
			{	
				echo("---------- MODE 2 OR 3 PICKED, BUT UNDER 2 PLAYERS, SO SET TO MODE 1");
				if(!($ModeVote[1] == $ModeVote[2] && $ModeVote[2] == $ModeVote[3]))			//if all votes are tied, no need to display this message tag addgamemode
					messageAll('', "<font:impact:24>\c5 The selected mode requires at least 2 players. A singleplayer mode was chosen instead.");
				
				while($DelivMode == 3 || $DelivMode == 2)		//tag addgamemode HERE ALSO						
				{
					%randMode = getRandom(1,%numModes);
					$DelivMode = %randMode;
				}
			}
				
			$ModeVote[1] = 0;
			$ModeVote[2] = 0;
			$ModeVote[3] = 0;
			$RoundNum = 1;
			%mg = $DefaultMiniGame;
			for(%i = 0; %i < %mg.numMembers; %i++)
			{
				%member = %mg.member[%i];
				%member.hasVoted = 0;
			}

			//de-activate pizza item zones if not mode 3. Otherwise, make sure they're activated			//tag addgamemode if new mode does not require the pizza item pickups
			for(%i = 1; %i <= $NumPizzaLocations; %i++)
			{
				if($DelivMode == 3)
				{
					if($PizzaDeliveryGamemodePizzaLocations[%i].isZoneBrick == 1)
					{
						$PizzaDeliveryGamemodePizzaLocations[%i].physicalZone.deactivate();
						$PizzaDeliveryGamemodePizzaLocations[%i].trigger.active = 0;
					}
				}
				else
				{
					if($PizzaDeliveryGamemodePizzaLocations[%i].isZoneBrick == 1)
					{
						$PizzaDeliveryGamemodePizzaLocations[%i].physicalZone.activate();
						$PizzaDeliveryGamemodePizzaLocations[%i].trigger.active = 1;
					}
				}
			}
			
			
			if($DelivMode == 3)
			{
				//Make sure no one is bomberClient at round start
				$bomberClient = 0;
				//select bomber some time after starting gates open
				schedule(36000,0,activateBomb,1);
				$selectBomberTimer = 37;
				selectBomberCountDownLoop();
				//Reset bomberGoneDetect
				$bomberGoneDetect = 0;
				//Clear all bots
				for(%j = 1; %j <= $PizzaDeliveryGamemodeNumLocations; %j++)	
				{
					if(isObject($PizzaDeliveryGamemodeBots[%j].hbot))
						$PizzaDeliveryGamemodeBots[%j].hBot.schedule(3000, "delete");
				}
			}
			else
			{
				//reset default respawn time	-no need to reset it - it will always be on 10000 anyway
				//$DefaultMiniGame.respawntime = 10000;
				
				//make sure no one is bomberClient, because that mode ended
				$bomberClient = 0;
				
				//Make sure ppl get their pizza!
				schedule(500,0,resetPizzaCount);
			}
			
			//Make sure $Mode2Deliv gets defined at the beginning of the round
			if($DelivMode == 2)
			{
				$Mode2Deliv = $PizzaDeliveryGamemodeLocations[getRandom(1,$PizzaDeliveryGamemodeNumLocations)];
			}
			
		}
		else if($RoundNum == 1)
		{
			messageAll('', "<font:impact:24>\c5 Don't forget to vote for the next mode:");
			messageAll('', "<font:impact:24>\c5 Use  \c6/vote (mode number)  \c5and  \c6/modes  \c5for more info.");
		}
		if($DelivMode == 1)
		{
			%modeName = "ONE FOR ONE";
		}
		else if($DelivMode == 2)
		{
			%modeName = "ONE FOR ALL";
		}
		else if($DelivMode == 3)
		{
			%modeName = "EXPLOSIVE PIZZA";
		}
			
		for(%i = 0; %i < $DefaultMinigame.numMembers; %i++)
		{
			%cl = $DefaultMinigame.member[%i];
			%cl.centerPrint("<font:impact:38>\c6BEGINNING:  <font:impact:44><color:b4b4b4>" @ %modeName, 12);
			
			//Now that the new DelivMode is set, respawn all players (the automatic player spawning on mini reset sometimes happens too early - before the true DelivMode is set for that round)
			//echo("Spawning player after reset -------- DelivMode is " @ $DelivMode);
			if(isObject(%cl.player))
				%cl.spawnPlayer();
		}
		
		cancel($compassSchedule);
		compassLoop();
		cancel($botGestureSchedule);
		botGestureLoop();
   }
	
    function gameConnection::spawnPlayer(%this)
    {
		//echo("DEBUGTEST:  function 41");
        parent::spawnPlayer(%this);
		
		%this.isSpectator = 0;
		%this.lastSpawnTime = getSimTime();
		
		//kill players that join during mode 3 so they will be made spectators
		if($DelivMode == 3 && %this.hasStartedFirstTimerSchedule != 1 && getSimTime() - $DefaultMinigame.lastResetTime >= 26000)	//hhh
		{
			for(%j = 1; %j <= 20; %j++)
			{
				%vehspawn = $VehicleSpawnBricks[%j];
				if($VehicleSpawnBricks[%j].isVehicleActive == 0 && %this.hasStartedFirstTimerSchedule != 1)
				{
					schedule(33,0,FirstTimerSetVehicle,%this,$VehicleSpawnBricks[%j]);
					%this.hasStartedFirstTimerSchedule = 1;
				}
			}
			%this.player.kill();
			messageClient(%this, '', "<font:Impact:21>\c5 You spawned during an elimination round.");
		}
		//Set the initial dropoff location, reset pizzaCount to max capacity after mini resets
		if($DelivMode == 1)
		{
        		%this.deliverTo = $PizzaDeliveryGamemodeLocations[getRandom(1,$PizzaDeliveryGamemodeNumLocations)];
		}
		if($DelivMode == 2)
		{
			%this.deliverTo = $Mode2Deliv;
		}
		%this.deliverFromPos = %this.player.getposition(); 	//This is needed to judge how many points a player deserves for a delivery (it will be based on the distance traveled from the previous delivery location, or in this case, the distance from the player's spawn)
		
		if($DelivMode != 3)
		{
			//when client spawns, give max capacity of pizza that their vehicle can carry. This method works as long as clients get the vehicle represented by their vehicleChoice when they spawn, which should always be the case
			if(!%this.vehicleChoice || %this.vehicleChoice == 1 || %this.vehicleChoice == 2 || %this.vehicleChoice == 3)	//tag addvehicle
			{
				%this.pizzaCount = 3;
			}
			else if(%this.vehicleChoice == 4 || %this.vehicleChoice == 5 || %this.vehicleChoice == 6)
			{
				%this.pizzaCount = 4;
			}
			else if(%this.vehicleChoice == 7)
			{
				%this.pizzaCount = 5;
			}
			else if(%this.vehicleChoice == 8)
			{
				%this.pizzaCount = 7;
			}
		}
		else
		{
			//talk("Code thinks we're in Mode 3 so didn't give pizza on spawn");
			%this.pizzaCount = 0;
		}
		
		%this.alreadyWon = 0;

		if(%this.hasStartedFirstTimerSchedule == 1)
		{
			schedule(500,0,NonFirstTimerSetVehicle,%this);
		}
		
		if(%this.hasStartedFirstTimerSchedule != 1)	//removed  && %this.deliverTo != ""		tag fixit
		{
			%this.toggleBoard = 1;
			%this.score = 0;
			for(%j = 1; %j <= 20; %j++)
			{
				%vehspawn = $VehicleSpawnBricks[%j];
				if($VehicleSpawnBricks[%j].isVehicleActive == 0 && %this.hasStartedFirstTimerSchedule != 1)
				{
					schedule(33,0,FirstTimerSetVehicle,%this,$VehicleSpawnBricks[%j]);
					%this.hasStartedFirstTimerSchedule = 1;
					%this.schedule(2000,spawnPlayer);
				}
			}
		}

				
    }

	  
};

//echo("DEBUGTEST:  just before activating PizzaDelivery package");
if($GameModeArg $= "Add-Ons/GameMode_Pizza_Delivery/gamemode.txt")
   activatePackage(GameModePizzaDeliveryPackage);

// more time to fly out of a burning car
$CorpseTimeoutValue = 7000;

//special event to explode vehicles that are left in the garage
registerOutputEvent("fxDTSBrick", "explodeNearVehicle", "");
function fxDTSBrick::explodeNearVehicle(%obj)
{
	//echo("DEBUGTEST:  function 42");
   %vehicle = %obj.vehicle;
   if(!isObject(%vehicle))
      return;

   %delta = vectorSub(%vehicle.getPosition(), %obj.getPosition());
   //echo("len = " @ vectorLen(%delta));
   if(vectorLen(%delta) < 5) //7.5)
      %vehicle.finalExplosion(); //damage(%vehicle, %vehicle.getPosition(), 10000, $DamageType::Default);
}


//special event to win the round
registerOutputEvent("GameConnection", "winRace", "");
function GameConnection::winRace(%client)
{
	//echo("DEBUGTEST:  function 43");
	//If client on a winning streak
	if($PreviousWinner == %client)
	{
		%client.winstreak += 1;		//this value is always one less than their true winstreak because it starts counting on the 2nd win
		if(%client.highestWinstreak < %client.winstreak + 1)
			%client.highestWinstreak = %client.winstreak + 1;
	}
	else
		%client.winstreak = 0;
	
	//add a win in the client's stats
	%client.totalWins += 1;
	if($DelivMode == 1)
	{
		%client.totalM1Wins += 1;
	}	
	else if($DelivMode == 2)
	{
		%client.totalM2Wins += 1;
	}
	else if($DelivMode == 3)				//tag addgamemode
	{
		%client.totalM3Wins += 1;
	}
	
   %mg = %client.miniGame;

   %c = $DefaultMinigame.numMembers;
   %winner = %client;
   for(%i = 0; %i < %c; %i++)
   {
		%member = $DefaultMinigame.member[%i];

        if(!isObject(%member.player)) continue;

        if(%member == %winner) continue;
	
        %member.player.delete();
        %member.camera.setOrbitMode(%winner.player, %winner.player.getTransform(), 0.5, 10, 10, false);
        %member.setControlObject(%member.camera);
   }

   if(!isObject(%mg))
      %mg = $DefaultMiniGame;

   if(!isObject(%mg))
      return;

   //if race start time is not available, use time since last reset
   %startTime = %mg.raceStartTime;
   if(%startTime <= 0)
      %startTime = %mg.lastResetTime;

   %elapsedTime = getSimTime() - %startTime;
   %elapsedTime = mFloor(%elapsedTime / 1000);
   
   //This can be used if you want different winning messages for different modes, but for now it will commented out and all modes will have the same winning message
   //if($DelivMode == 1) {
   //	centerprintAll('<font:impact:33><color:66cc33>Employee of the day:   <font:impact:39>\c6' @ %client.getPlayerName(),16);
   //}
   //if($DelivMode == 2) {
   //	centerprintAll("<font:impact:33><color:66cc33>Employee of the day:   <font:impact:39>\c6" @ %client.getPlayerName(),16);
   //}
   
   //Winning message for all modes
	if(%client.winstreak > 0)
		centerprintAll("<font:impact:33><color:66cc33>Employee of the day:   <font:impact:39>\c6" @ %client.getPlayerName() @ "   <font:impact:35>\c3" @ %client.winstreak+1 @ " DAY STREAK!",16);
	else
		centerprintAll("<font:impact:33><color:66cc33>Employee of the day:   <font:impact:39>\c6" @ %client.getPlayerName(),16);

	
   %mg.scheduleReset(16550);

   //stop round music
	if(isObject(RoundMusic))
	{
	RoundMusic.schedule(33,"delete");
	$canSkipMusic = 0;	//prevents music skipping while the win music is playing
	}

	//play round winning music
	new AudioEmitter(RoundWinMusic)
	{
		position = "0 0 0";
		profile = "musicData_MarioKartWin";
		useProfileDescription = "0";
		description = "AudioLooping2D";
		type = "0";
		volume = "1";
		outsideAmbient = "1";
		ReferenceDistance = "4";
		maxDistance = "9001";
		isLooping = "0";
	};
	RoundWinMusic.schedule(16550,"delete");

	//used to tell if client is on a winning streak
	$PreviousWinner = %client;
}  



//Edit the maxWheelSpeed of some vehicles in Vehicle_BikePack, edit cameraOffset of the velocipede vehicle (makes it higher), and edit the vehicle springs (more dampening, less force)
BicycleVehicle.maxWheelSpeed = 26;
DeliveryVehicle.maxWheelSpeed = 33;
MotorcycleVehicle.maxWheelSpeed = 45;
ScooterVehicle.maxWheelSpeed = 33;
VelocipedeVehicle.maxWheelSpeed = 28.5;
VelocipedeVehicle.cameraOffset = 5.4;
DirtBikeVehicle.maxWheelSpeed = 40;
VespaVehicle.maxWheelSpeed = 37;
KeiCarSS800Vehicle.maxWheelSpeed = 48;
BikePackSpring.force = 2000;
BikePackSpring.damping = 900;

